{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            Copyright (c) 2018 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Reg;

interface

{$IFDEF LCLTMSWEB}
uses
  FormEditingIntf, PropEdits, LResources, TMSWebCoreIDEOptions;
{$ENDIF}

procedure Register;

implementation


uses
  SysUtils, Classes, Graphics, Menus,
  WEBLib.Controls, WEBLib.StdCtrls,
  WEBLib.Forms, WEBLib.Modules, WEBLib.Dialogs, WEBLib.ExtCtrls, WEBLib.Grids,
  WEBLib.FlexControls, WEBLib.ComCtrls, WEBLib.WebCtrls, WEBLib.DBCtrls,
  WEBLib.Buttons, WEBLib.Login, WEBLib.REST, WEBLib.Mask, WEBLib.Lists, WEBLib.SyntaxMemo,
  WEBLib.Devices,
  WEBLib.WebSocketClient, WEBLib.myCloudData, WEBLib.Google,
  WEBLib.GoogleCalendar, WEBLib.JQCtrls, WEBLib.JQGrid,
  WEBLib.GoogleChart, WEBLib.GoogleReCaptcha, WEBLib.SignIn, WEBLib.PayPal,
  WEBLib.EditAutocomplete, WEBLib.Menus, WEBLib.DB, WEBLib.CDS, WEBLib.ClientConnector,
  WEBLib.ThreeJsControls, WEBLib.ThreeJsChart, WEBLib.ThreeJsMathChart,
  WEBLib.IndexedDb, WEBLib.MyCloudCDS, WEBLib.FirestoreCDS, WEBLib.SQLCDS, WEBLib.Actions,
  WEBLib.FaunaDbCDS, WEBLib.DreamFactoryCDS, WEBLib.RadServerCDS, WEBLib.Slider,
  WEBLib.ContinuousScroll;

const
  cPage = 'TMS Web';
  cPageDB = 'TMS Web Data Controls';
  cPageDBACC = 'TMS Web Data Access';
  cPageSys = 'TMS Web System';
  cPageHTTP = 'TMS Web REST';
  cPageJQ = 'TMS Web jQuery';
  cPageExt = 'TMS Web 3rd party';
  cPage3D = 'TMS Web 3D';
  cTMSWebAddIn = 'TMS Web ';
  cBmpResName = 'TMSWEBBMP';

procedure Register;
begin
  RegisterComponents(cPage, [TWebLabel, TWebButton, TWebEdit, TWebSpinEdit, TWebMaskEdit, TWebDateTimePicker, TWebListBox, TWebComboBox, TWebColorPicker, TWebCheckBox, TWebRadioButton, TWebMemo, TWebRadioGroup, TWebPaintBox, TWebTrackbar, TWebScrollBox, TWebProgressBar, TWebSplitter, TWebPanel, TWebImageControl, TWebLinkLabel, TWebRichEdit, TWebTabSet, TWebPageControl, TWebTabSheet, TWebSpeedButton, TWebToolBar, TWebRichEditToolBar, TWebMainMenu, TWebGridPanel, TWebMessageDlg, TWebToggleButton, TWebBitBtn, TWebGroupBox, TWebStringGrid, TWebTableControl, TWebLoginPanel, TWebHTMLContainer, TWebHTMLForm, TWebHTMLDiv, TWebHTMLSpan, TWebHTMLAnchor, TWebStretchPanel, TWebResponsiveGrid, TWebWaitMessage, TWebListControl, TWebBadge, TWebTreeView, TWebAccordion]);
  RegisterComponents(cPage, [TWebBrowserControl, TWebGoogleMaps, TWebGoogleDrive, TWebYouTube, TWebTwitterFeed, TWebGoogleChart, TWebGoogleReCaptcha, TWebSignIn, TWebPayPal, TWebEditAutoComplete]);
  RegisterComponents(cPage, [TWebResponsiveGridPanel, TWebImageSlider, TWebContinuousScroll]);
  RegisterComponents(cPageSys, [TWebTimer, TWebGeolocation, TWebMultimediaPlayer, TWebFileUpload, TWebFilePicker, TCSSCodeManager, TWebSocketClient, TWebClientConnector, TWebCamera, TWebMediaCapture]);
  RegisterComponents(cPageDB, [TWebDBLabel, TWebDBEdit, TWebDBCheckBox, TWebDBSpinEdit, TWebDBMaskEdit, TWebDBMemo, TWebDBDateTimePicker, TWebDBRadioGroup, TWebDBLinkLabel, TWebDBImageControl, TWebDBTableControl, TWebDBResponsiveGrid, TWebDBGrid, TWebDBNavigator, TWebDBComboBox, TWebDBEditAutoComplete]);
  RegisterComponents(cPageDBACC, [TWebClientDataSet, TWebClientConnection, TWebDataSource, TWebIndexedDbClientDataset, TWebMyCloudDbClientDataset, TWebFirestoreClientDataset, TWebSQLRestConnection, TWebSQLRestClientDataset, TWebFaunaDBClientDataset, TWebDreamFactoryClientDataSet, TWebRadServerClientDataset]);
  RegisterComponents(cPageHTTP, [TWebHTTPRequest, TWebRESTClient, TWebmyCloudData, TWebGoogleClient, TWebGoogleCalendar]);

  RegisterComponents(cPageJQ, [TWebJQXCalendar, TWebJQXColorPicker, TWebJQXComboBox, TWebJQXDateTimeInput, TWebJQXDropDownList, TWebJQXGrid, TWebJQXMaskedInput, TWebJQXMenu, TWebJQXNumberInput, TWebJQXRating, TWebJQXKnob, TWebJQXProgressBar, TWebJQXSlider, TWebJQXButton, TWebJQXButtonGroup, TWebJQXRangeSelector, TWebJQXTagCloud, TWebJQXResponsivePanel, TWebJQXTabs, TWebJQXTabSheet]);

  RegisterComponents(cPage3D, [TWebThreeJsPaintBox, TWebThreeJsChart, TWebThreeJsMathChart, TWebThreeJsModelBox]);

  RegisterComponents(cPageExt, [TWebSyntaxMemo, TWebQRDecoder, TWebBarcodeDecoder]);

  RegisterComponents(cPage, [TWebElementActionList]);

  {$IFDEF LCLTMSWEB}
  FormEditingHook.RegisterDesignerBaseClass(TWebForm);
  RegisterPropertyEditor(TypeInfo(AnsiString), TWebForm, 'LCLVersion', THiddenPropertyEditor);
  RegisterPropertyToSkip(TWebForm,'LCLVersion','Property streamed by older version','');
  {$ENDIF}
end;

{$IFDEF LCLTMSWEB}
initialization
  WebFormClass := TWebForm;
{$ENDIF}

end.
