{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
unit libfirestore;

{$mode objfpc}
{$modeswitch externalclass}

interface

uses
  JS, Web;

type
  TFirestore = class;
  TFirestoreCollection = class;

  TFireBaseError = Class external name 'Error'
  Public
    property message : String Read FMessage;
    property name : String Read FName;
  end;

  TFireBaseApp = class(TJSObject)
  end;

  TFireBaseAuthProvider = class(TJSObject)
  end;

  TFireBaseAuthUser = class(TJSObject)
  public
    property displayName: String read fDisplayName;
    property email: String read fEmail;
  end;


  TFireBaseGoogleAuthProvider = class external name 'firebase.auth.GoogleAuthProvider' (TJSObject)
  public
    constructor New;
    procedure addScope(aScope: String); external name 'addScope';
  end;

  TFireBaseAuthStateObserver = reference to Procedure(aUser: TFireBaseAuthUser);
  TFireBaseJSErrorProc = reference to Procedure(anError: TFireBaseError);
  TFireBaseUnsubscribe = reference to Procedure;

  TFireBaseAuth = class(TJSObject)
  public
    function signInWithPopup(aProvider: TFireBaseGoogleAuthProvider): TJSPromise; external name 'signInWithPopup';
    function signOut: TJSPromise; external name 'signOut';
    function onAuthStateChanged(observer: TFireBaseAuthStateObserver): TFireBaseUnsubscribe; external name 'onAuthStateChanged'; overload;
    function onAuthStateChanged(observer: TFireBaseAuthStateObserver; errorProc: TFireBaseJSErrorProc): TFireBaseUnsubscribe; external name 'onAuthStateChanged'; overload;
    property currentUser: TFireBaseAuthUser read fCurrentUser;
  end;

  TFireBase = class external name 'firebase' (TJSObject)
    class var apps: TJSArray;
    class function initializeApp(aConfig: TJSObject): TFireBaseApp;
    class function firestore: TFirestore;
    class function auth: TFireBaseAuth;
  end;

  TFirestore = class (TJSObject)
    function collection(collectionPath: string): TFirestoreCollection; external name 'collection';
  end;

  TFirestoreDocument = class(TJSObject)
    function doSet(aData: TJSObject): TJSPromise; external name 'set';
    function get(options: TJSObject): TJSPromise; external name 'get';
    function delete: TJSPromise; external name 'delete';
    function update(aData: TJSObject): TJSPromise; external name 'update';
  end;

  TFirestoreQuery = class(TJSPromise)
    function get(options: TJSObject): TJSPromise; external name 'get';
    function orderBy(aField: String): TFirestoreQuery; external name 'orderBy';
    function orderBy(aField: String; aDirection: String): TFirestoreQuery; external name 'orderBy';
    function where(aField: String; anOperator: String; aValue: JSValue): TFirestoreQuery; external name 'where';
    function limit(aNumber: Integer): TFirestoreQuery; external name 'limit';
    function startAt(aValue: JSValue): TFirestoreQuery; external name 'startAt';
    function startAfter(aValue: JSValue): TFirestoreQuery; external name 'startAfter';
    function endAt(aValue: JSValue): TFirestoreQuery; external name 'endAt';
    function endBefore(aValue: JSValue): TFirestoreQuery; external name 'endBefore';
  end;

  TFirestoreCollection = class(TFirestoreQuery)
    function add(data: TJSObject): TJSPromise; external name 'add';
    function get: TJSPromise; external name 'get';
    function doc(anId: String): TFirestoreDocument; external name 'doc';
  end;

  TFirestoreQueryDocumentSnapshot = class(TJSObject)
  public
    function data: TJSObject; external name 'data';
    property id: String read fId;
  end;

  TJSFirestoreQSEvent = reference to procedure(doc: TFirestoreQueryDocumentSnapshot);

  TFirestoreQuerySnapshot = class(TJSObject)
  public
    procedure forEach(aCallBack : TJSFirestoreQSEvent); external name 'forEach';
    property docs: TJSArray read fdocs;
  end;

  TFireBaseAuthUserCredential = class(TJSObject)
  public
    property user: TFireBaseAuthUser read fUser;
  end;

  TFirestoreTimestamp = class external name 'firebase.firestore.Timestamp' (TJSObject)
  public
    seconds: Integer; 
    nanoseconds: Integer; 
    constructor New(seconds: Integer; nanoSeconds: Integer);
    function toDate: TJSDate;
    class function fromDate(aDate: JSValue): TFirestoreTimestamp;
  end;

function CreateFirebaseError(aName: String; aMessage: String): TFireBaseError;

// FireBase App must be initialized before calling
function getLoggedInUser: TJSPromise;

implementation
end.
