{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.GoogleChart;

{$DEFINE NOPP}

interface

uses
  Classes, Web, JS, WEBLib.Controls, WEBLib.Graphics;

const
  MAJ_VER = 1; // Major version nr.
  MIN_VER = 0; // Minor version nr.
  REL_VER = 1; // Release nr.
  BLD_VER = 0; // Build nr.

  // version history
  // 1.0.0.0 : First release
  // 1.0.0.1 : Fixed: Issue with OnLoaded and OnSelect events in Release mode
  // 1.0.1.0 : New: Support for multiple series with gctScatter type chart

type
  TGoogleChartType = (gctArea, gctBar, gctBubble, gctBubbleColor, gctCandlestick,
    gctColumn, {*gctGauge, gctGeo,*} gctLine, gctPie, gctScatter, gctTimeLine);
  TGoogleChartEasing = (gceLinear, gceIn, gceOut, gceInAndOut);
  TGoogleChartStacked = (gcsDisabled, gcsAbsolute, gcsPercent, gcsRelative);
  TGoogleChartPosition = (gcpBottom, gcpLeft, gcpIn, gcpNone, gcpRight, gcpTop);
  TGoogleChartAlignment = (gcaAuto, gcaStart, gcaCenter, gcaEnd);
  TGoogleChartTooltip = (gcttHover, gcttNone, gcttSelect);
  TGoogleChartPieText = (gcptPercentage, gcptValue, gcptLabel, gcptNone);
  TGoogleChartPointShape = (gcpsCircle, gcpsTriangle, gcpsSquare, gcpsDiamond,
    gcpsStar, gcpsPolygon);
  TGoogleChartCurveType = (gcctNone, gcctFunction);

  TGoogleChart = class;
  TGoogleChartSeries = class;
  TGoogleChartSeriesItem = class;

  TGoogleChartDataPoint = record
    Title: string;
    X: Double;
    Y: Double;
    Minimum: Double;
    Maximum: Double;
    StartTime: TDateTime;
    EndTime: TDateTime;
    Series: string;
    Size: Double;
    Value: Double;
    Country: string;
    Offset: Double;
    Color: TColor;
  end;

  TGoogleChartAnimationRecord = record
    Duration: string;
    Easing: string;
    Startup: string;
  end;

  TGoogleChartAnnotations = record
    AlwaysOutside: string;
    BoxStyle: string;
    Style: string;
    TextStyle: string;
  end;

  TGoogleChartColor = record
    Stroke: string;
    StrokeWidth: string;
    Fill: string;
  end;

  TGoogleChartViewWindow = record
    Max: string;
    Min: string;
  end;

  TGoogleChartAxisRecord = record
    Baseline: string;
    BaselineColor: string;
    Direction: string;
    Format: string;
    GridLines: string;
    MinorGridLines: string;
    TextPosition: string;
    TextStyle: string;
    Ticks: string;
    Title: string;
    TitleTextStyle: string;
    SlantedText: string;
    SlantedTextAngle: string;
    MaxValue: string;
    MinValue: string;
    ViewWindowMode: string;
    ViewWindow: TGoogleChartViewWindow;
  end;

  TGoogleChartLegendRecord = record
    Position: string;
    Alignment: string;
    TextStyle: string;
  end;

  TGoogleChartTooltipRecord = record
    IgnoreBounds: string;
    ShowColorCode: string;
    TextStyle: string;
    Trigger: string;
  end;

  TGoogleChartBubble = record
    Opacity: string;
    Stroke: string;
    TextStyle: string;
  end;

  TGoogleChartColorAxisLegend = record
    Position: string;
    TextStyle: string;
    NumberFormat: string;
  end;

  TGoogleChartColorAxis = record
    MinValue: string;
    MaxValue: string;
    Values: string;
    Colors: string;
    Legend: TGoogleChartColorAxisLegend;
  end;

  TGoogleChartSizeAxis = record
    MaxSize: string;
    MaxValue: string;
    MinSize: string;
    MinValue: string;
  end;

  TGoogleChartCandleStick = record
    HollowIsRising: string;
    FallingColor: TGoogleChartColor;
    RisingColor: TGoogleChartColor;
  end;

  TGoogleChartOptions = record
    //General (not Gauge / Pie)
    Animation: TGoogleChartAnimationRecord;
    Annotations: TGoogleChartAnnotations;
    AxisTitlesPosition: string;
    BackgroundColor: TGoogleChartColor;
    Colors: string;
    DataOpacity: string;
    EnableInteractivity: string;
    FocusTarget: string;
    FontSize: string;
    FontName: string;
    HAxis: TGoogleChartAxisRecord;
    IsStacked: string;
    Legend: TGoogleChartLegendRecord;
    Orientation: string;
    ReverseCategories: string;
    Series: string;
    Title: string;
    TitlePosition: string;
    TitleTextStyle: string;
    Tooltip: TGoogleChartTooltipRecord;
    VAxis: TGoogleChartAxisRecord;
    //Column / Bar / Area / CandleStick / Line
    VAxes: string;
    //Column / Bar / Scatter
    Trendlines: string;
    //Area / Bubble / CandleStick / Line
    SelectionMode: string;
    //Area / CandleStick / Line / Pie / Scatter
    AggregationTarget: string;
    //Area
    AreaOpacity: string;
    InterpolateNulls: string;
    //Bubble
    Bubble: TGoogleChartBubble;
    ColorAxis: TGoogleChartColorAxis;
    SizeAxis: TGoogleChartSizeAxis;
    SortBubbleBySize: string;
    //CandleStick
    CandleStick: TGoogleChartCandleStick;
    //Gauge
    GreenColor: string;
    GreenFrom: string;
    GreenTo: string;
    MajorTicks: string;
    Max: string;
    Min: string;
    MinorTicks: string;
    RedColor: string;
    RedFrom: string;
    RedTo: string;
    YellowColor: string;
    YelloFrom: string;
    YellowTo: string;
    //Line
    CurveType: string;
    //Pie
    Is3D: string;
    PieHole: string;
    PieSliceBorderColor: string;
    PieSliceText: string;
    PieSliceTextStyle: string;
    PieStartAngle: string;
    PieResidueSliceColor: string;
    PieResidueSliceLabel: string;
    Slices: string;
    SliceVisibilityTreshold: string;
  end;

  TGoogleChartSelectEventArgs = class(TPersistent)
  published
    property PointIndex: Integer read FPointIndex write FPointIndex;
    property SeriesIndex: Integer read FSeriesIndex write FSeriesIndex;
  end;

  TGoogleChartSelectEvent = procedure(Sender: TObject; Event: TGoogleChartSelectEventArgs) of object;
  TGoogleChartCustomizeChartEvent = procedure(Sender: TObject; var Options: TGoogleChartOptions) of object;
  TGoogleChartCustomizeChartJSON = procedure(Sender: TObject; var Options: string) of object;

  TGoogleChartSeriesValueItem = class(TCollectionItem)
  published
    property DataPoint: TGoogleChartDataPoint read FDataPoint write FDataPoint;
  end;

  TGoogleChartSeriesValues = class(TCollection)
  public
    constructor Create(AOwner: TGoogleChartSeries); reintroduce;
    procedure AddSinglePoint(AValue: Double; ALabel: string = '');
    procedure AddPiePoint(AValue: Double; ALabel: string = ''; Offset: Double = 0; Color: TColor = clNone);
    procedure AddXYPoint(X, Y: Double);
    procedure AddCandlestickPoint(X, Y, Minimum, Maximum: Double; ALabel: string = '');
    procedure AddTimelinePoint(StartTime, EndTime: TDateTime; ALabel: string = '');
    procedure AddBubblePoint(X, Y: Double; Series: string; Size: Double; ALabel: string = '');
    procedure AddBubbleColorPoint(X, Y: Double; Value: Double; ALabel: string = '');
//    procedure AddGeoPoint(Country: string; Value: Double);
    property Items[Index: integer]: TGoogleChartSeriesValueItem read GetItems write SetItems; default;
  end;

  TGoogleChartLineOptions = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChartSeriesItem); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property PointSize: Integer read FPointSize write SetPointSize default 7;
    property PointShape: TGoogleChartPointShape read FPointShape write SetPointShape default gcpsCircle;
    property LineWidth: Integer read FLineWidth write SetLineWidth default 2;
  end;

  TGoogleChartSeriesItem = class(TCollectionItem)
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    property Values: TGoogleChartSeriesValues read FValues;
  published
    property Title: string read FTitle write FTitle;
    property ChartType: TGoogleChartType read FChartType write SetChartType default gctBar;
    property Color: TColor read FColor write SetColor default clNone;
    property Line: TGoogleChartLineOptions read FLine write SetLine;
    property Tag: integer read FTag write FTag default 0;
  end;

  TGoogleChartSeries = class(TOwnedCollection)
  public
    constructor Create(AOwner: TGoogleChart); overload;
    function GetOwner: TPersistent; override;
    function Add: TGoogleChartSeriesItem; reintroduce;
    function Insert(Index: Integer):TGoogleChartSeriesItem; reintroduce;
    property Items[Index: integer]: TGoogleChartSeriesItem read GetItems write SetItems; default;
  end;

  TGoogleChartAppearance = class;

  TGoogleChartAxis = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChartAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property MaxValue: Integer read FMaxValue write SetMaxValue default 0;
    property MinValue: Integer read FMinValue write SetMinValue default 0;
    property AutoMaxMinValue: Boolean read FAutoMaxMinValue write SetAutoMaxMinValue default True;
  end;

  TGoogleChartAnimation = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChartAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Duration: Integer read FDuration write SetDuration default 1000;
    property Easing: TGoogleChartEasing read FEasing write SetEasing default gceOut;
    property Startup: Boolean read FStartup write SetStartup default true;
  end;

  TGoogleChartBackground = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChartAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Color: TColor read FColor write SetColor default clNone;
    property BorderColor: TColor read FBorderColor write SetBorderColor default clNone;
    property BorderWidth: Integer read FBorderWidth write SetBorderWidth default 0;
  end;

  TGoogleChartLegend = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChartAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Position: TGoogleChartPosition read FPosition write SetPosition default gcpRight;
    property Alignment: TGoogleChartAlignment read FAlignment write SetAlignment default gcaAuto;
  end;

  TGoogleChartPie = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChartAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Enable3D: Boolean read FEnable3D write SetEnable3D default false;
    property PieHole: Double read FPieHole write SetPieHole;
    property PieSliceText: TGoogleChartPieText read FPieSliceText write SetPieSliceText;
  end;

  TGoogleChartLine = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChartAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property CurveType: TGoogleChartCurveType read FCurveType write SetCurveType default gcctNone;
  end;

  TGoogleChartAppearance = class(TPersistent)
  public
    constructor Create(AOwner: TGoogleChart); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Animation: TGoogleChartAnimation read FAnimation write SetAnimation;
    property Background: TGoogleChartBackground read FBackground write SetBackground;
    property Legend: TGoogleChartLegend read FLegend write SetLegend;
    property ReverseCategories: Boolean read FReverseCategories write SetReverseCategories default False;
    property Stacked: TGoogleChartStacked read FStacked write SetStacked default gcsDisabled;
    property Tooltip: TGoogleChartTooltip read FTooltip write SetTooltip default gcttHover;
    property PieChart: TGoogleChartPie read FPieChart write SetPieChart;
    property LineChart: TGoogleChartLine read FLineChart write SetLineChart;
    property VAxis: TGoogleChartAxis read FVAxis write SetVAxis;
    property HAxis: TGoogleChartAxis read FHAxis write SetHAxis;
  end;

  TGoogleChart = class(TCustomControl)
  protected
    function CreateElement: TJSElement; override;
    procedure UpdateElement; override;
    procedure BuildChartData(Serie: TGoogleChartSeriesItem; DataPoint: TGoogleChartDataPoint; DataArray: TJSArray; AddTitle: Boolean);
    function BuildColor(PropertyName: string; Color: TGoogleChartColor; First: Boolean): string;
    function GetChartObject: TJSObject;
    function GetDataObject: TJSObject;
    function HandleLoaded(Event: TJSEvent): Boolean;
    function HandleSelect(PointIndex, SeriesIndex: Integer): Boolean;
    function GetID: string; override;
    procedure Loaded; override;
    procedure SetSampleData;
  public
    procedure CreateInitialize; override;
    constructor Create(AOwner: TComponent); overload; override;
    destructor Destroy; override;
    procedure SetBounds(X, Y, AWidth, AHeight: Integer); override;
    property Chart: TJSObject read GetChartObject;
    property Data: TJSObject read GetDataObject;
//    property MapsAPIKey: string read FMapsAPIKey write FMapsAPIKey;
    procedure SetOption(AOption, AValue: string); overload;
    procedure SetOption(AOption: string; AValue: Boolean); overload;
    procedure SetOption(AOption: string; AValue: TJSObject); overload;
  published
    property Align;
    property AlignWithMargins;
    property Anchors;
    property Enabled;
    property ElementClassName;
    property ElementID;
    property ElementPosition;
    property Font;
    property Height;
    property Left;
    property Margins;
    property Options: TStringList read FOptions write FOptions;
    property Series: TGoogleChartSeries read FSeries write FSeries;
    property Top;
    property Visible;
    property Width;
    property Appearance: TGoogleChartAppearance read FAppearance write FAppearance;
    property Title: string read FTitle write SetTitle;

    property OnLoaded: TNotifyEvent read FOnLoad write FOnLoad;
    property OnSelect: TGoogleChartSelectEvent read FOnSelect write FOnSelect;
    property OnCustomizeChart: TGoogleChartCustomizeChartEvent read FOnCustomizeChart write FOnCustomizeChart;
    property OnCustomizeChartJSON:  TGoogleChartCustomizeChartJSON read FOnCustomizeChartJSON write FOnCustomizeChartJSON;
  end;

  TWebGoogleChart = class(TGoogleChart);

implementation
end.

