{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.JQCtrls;

{$DEFINE NOPP}

interface

uses
  Classes, WebLib.Graphics, SysUtils, Web, WebLib.Controls, js, libJQuery, jqwidget,
  WebLib.Menus, WEBLib.ExtCtrls;

type
  TJQXDayOfWeek = (dowMonday, dowTuesday, dowWednesday, dowThursday,
    dowFriday, dowSaturday, dowSunday, dowLocaleDefault);
  TJQXInputKind = (diDate, diTime, diDateTime);
  TJQXMenuMode = (mmHorizontal, mmVertical, mmPopup);
  TJQXColorMode = (cmHue, cmSaturation);
  TJQXSymbolPosition = (spLeft, spRight);
  TJQXInputMode = (imAdvanced, imSimple);
  //TJQXRatingPrecision = (rpFull, rpHalf);
  TJQXProgressOrientation = (poHorizontal, poVertical);
  TJQXProgressLayout = (plNormal, plReverse);
  TJQXTemplate = (ttDefault, ttPrimary, ttSuccess, ttWarning, ttDanger, ttInfo);
  TJQXHorizontalPosition = (hpLeft, hpRight, hpBoth);
  TJQXVerticalPosition = (vpTop, vpBottom, vpBoth);
  TJQXSliderMode = (smDefault, smFixed);
  TJQXKnobMarkType = (mtCircle, mtLine);
  TJQXKnobPointerType = (ptArrow, ptCircle, ptLine);
  TJQXPosition = (xpLeft, xpTop, xpCenter, xpBottom, xpRight, xpTopLeft,
    xpBottomLeft, xpTopRight, xpBottomRight);
  TJQXImagePosition = (ipAfterImage, ipAboveImage, ipBelowImage, ipBeforeImage, ipOverlay);
  TJQXGroupMode = (gmDefault, gmCheckBox, gmRadioButton);
  TJQXTagCloudSort = (tcsNone, tcsLabel, tcsValue);
  TJQXSortOrder = (soAscending, soDescending);
  TJQXTextCase = (tcOriginal, tcUpperCase, tcLowerCase, tcFirstUpper, tcCamelCase);
  TJQXAnimationType = (atNone, atFade, atSlide);
  TJQXTabPosition = (tpTop, tpBottom);
  TJQXToggleMode = (tmClick, tmDoubleClick, tmMouseEnter);

  TJQXCalendarEventArgs = class(TPersistent)
  published
    property Date: TDateTime read FDate write FDate;
  end;

  TJQXDateEvent = procedure(Sender: TObject; Event: TJQXCalendarEventArgs) of object;

  TJQXMenuEventArgs = class(TPersistent)
  published
    property Source: TMenuItem read FSource write FSource;
  end;

  TJQXItemEvent = procedure(Sender: TObject; Event: TJQXMenuEventArgs) of object;

  TJQXSliderEventArgs = class(TPersistent)
  published
    property Value: Double read FValue write FValue;
    property MinimumValue: Double read FMinimumValue write FMinimumValue;
    property MaximumValue: Double read FMaximumValue write FMaximumValue;
  end;

  TJQXSliderEvent = procedure(Sender: TObject; Event: TJQXSliderEventArgs) of object;

  TJQXButtonEventArgs = class(TPersistent)
  published
    property ButtonIndex: Integer read FButtonIndex write FButtonIndex;
  end;

  TJQXButtonEvent = procedure(Sender: TObject; Event: TJQXButtonEventArgs) of object;

  TJQXTagEventArgs = class(TPersistent)
  published
    property TagIndex: Integer read FTagIndex write FTagIndex;
    property TagLabel: String read FTagLabel write FTagLabel;
    property TagValue: Integer read FTagValue write FTagValue;
    property DisplayIndex: Integer read FDisplayIndex write FDisplayIndex;
  end;

  TJQXTagEvent = procedure(Sender: TObject; Event: TJQXTagEventArgs) of object;

  TJQXTabEventArgs = class(TPersistent)
  published
    property TabIndex: Integer read FTabIndex write FTabIndex;
  end;

  TJQXTabEvent = procedure(Sender: TObject; Event: TJQXTabEventArgs) of object;


  TJQXCustomControl = class(TjQueryCustomControl)
  protected
    function GetTheme(ATheme: string): string;
    function RequiredBaseURL: string; override;
    procedure RequiredScriptLoaded(Event: TJSEvent); override;
  public
    procedure SetTheme(AValue: string); virtual;
  published
    property Align;
    property AlignWithMargins;
    property Anchors;
    property Theme: string read FTheme write SetTheme;
    property Visible;
  end;

  TJQXCalendar = class(TJQXCustomControl)
  protected
    procedure UpdateElement; override;
    procedure UpdateSize;

    procedure SetDate(AValue: TDateTime);
    function GetDate: TDateTime;
    procedure SetEndDate(AValue: TDateTime);
    function GetEndDate: TDateTime;

    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
    procedure SetFirstDayOfWeek(AValue: TJQXDayOfWeek);
    procedure SetMaxDate(AValue: TDateTime);
    procedure SetMinDate(AValue: TDateTime);
    procedure SetMultiSelect(AValue: boolean);
    procedure SetOtherMonthDays(AValue: boolean);
    procedure SetShowToday(AValue: boolean);
    procedure SetWeekNumbers(AValue: boolean);
  public
    procedure InitJQuery; override;
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property FirstDayOfWeek: TJQXDayOfWeek read FFirstDayOfWeek write SetFirstDayOfWeek;
    property Date: TDateTime read GetDate write SetDate;
    property EndDate: TDateTime read GetEndDate write SetEndDate;
    property MaxDate: TDateTime read FMaxDate write SetMaxDate;
    property MinDate: TDateTime read FMinDate write SetMinDate;
    property MultiSelect: Boolean read FMultiSelect write SetMultiSelect;
    property OtherMonthDays: Boolean read FOtherMonthDays write SetOtherMonthDays;
    property ShowToday: Boolean read FShowToday write SetShowToday;
    property WeekNumbers: Boolean read FWeekNumbers write SetWeekNumbers;
    property OnDateClick: TJQXDateEvent read FOnDateClick write FOnDateClick;
    property OnNavigateClick: TJQXDateEvent read FOnNavigateClick write FOnNavigateClick;
  end;

  TWebJQXCalendar = class(TJQXCalendar);

  TJQXDateTimeInput = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;

    procedure SetDate(AValue: TDateTime);
    function GetDate: TDateTime;
    procedure SetEndDate(AValue: TDateTime);
    function GetEndDate: TDateTime;

    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
    procedure SetFirstDayOfWeek(AValue: TJQXDayOfWeek);
    procedure SetKind(AValue: TJQXInputKind);
    procedure SetMaxDate(AValue: TDateTime);
    procedure SetMinDate(AValue: TDateTime);
    procedure SetMultiSelect(AValue: boolean);
    procedure SetShowToday(AValue: boolean);
    procedure SetWeekNumbers(AValue: boolean);
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property FirstDayOfWeek: TJQXDayOfWeek read FFirstDayOfWeek write SetFirstDayOfWeek;
    property Date: TDateTime read GetDate write SetDate;
    property EndDate: TDateTime read GetEndDate write SetEndDate;
    property Kind: TJQXInputKind read FKind write SetKind;
    property MaxDate: TDateTime read FMaxDate write SetMaxDate;
    property MinDate: TDateTime read FMinDate write SetMinDate;
    property MultiSelect: boolean read FMultiSelect write SetMultiSelect;
    property ShowToday: boolean read FShowToday write SetShowToday;
    property WeekNumbers: boolean read FWeekNumbers write SetWeekNumbers;
    property OnDateClick: TJQXDateEvent read FOnDateClick write FOnDateClick;
  end;

  TWebJQXDateTimeInput = class(TJQXDateTimeInput);

  TJQXMenu = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    function GetMenuSource(Item: TMenuItem): string;
    function GetItemByName(AMenu: TMenuItem; Name: string): TMenuItem;

    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
    procedure SetMode(AValue: TJQXMenuMode);
    procedure SetMenu(AValue: TMainMenu);
    procedure ToggleItem(AMenuItem: TMenuItem; Disabled: Boolean);
  public
    procedure CreateInitialize; override;
    procedure BeginUpdate; override;
    procedure EndUpdate; override;
    procedure SetTheme(AValue: string); override;
    procedure SetItemEnabled(AMenuItem: TMenuItem);
    procedure SetItemDisabled(AMenuItem: TMenuItem);
  published
    property Mode: TJQXMenuMode read FMode write SetMode default mmHorizontal;
    property Menu: TMainMenu read FMenu write SetMenu;
    property OnItemClick: TJQXItemEvent read FOnItemClick write FOnItemClick;
  end;

  TWebJQXMenu = class(TJQXMenu);

  TJQXMaskedInput = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;

    function GetText: string;
    procedure SetMask(AValue: string);
    procedure SetText(AValue: string);
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property Mask: string read FMask write SetMask;
    property Text: string read GetText write SetText;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXMaskedInput = class(TJQXMaskedInput);

  TJQXColorPicker = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
  public
    procedure CreateInitialize; override;
    procedure BeginUpdate; override;
    procedure EndUpdate; override;

    function GetColor: TColor;
    procedure SetColorPickerColor(AValue: TColor);
    procedure SetColorMode(AValue: TJQXColorMode);
  published
    property Color: TColor read GetColor write SetColorPickerColor default clBlack;
    property ColorMode: TJQXColorMode read FColorMode write SetColorMode default cmSaturation;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXColorPicker = class(TJQXColorPicker);

  TJQXComboBox = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure HandleItemsChanged(Sender: TObject);
    function GetDisabled(AIndex: Integer): Boolean;
    procedure SetDisabled(AIndex: Integer; AValue: Boolean);
    function GetSelected(AIndex: Integer): Boolean;
    procedure SetSelected(AIndex: Integer; AValue: Boolean);
    procedure SetAutoComplete(AValue: Boolean);
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: Boolean); override;
    procedure SetMultiSelect(AValue: Boolean);
    procedure SetTextHint(AValue: string);
  public
    procedure CreateInitialize; override;
    destructor Destroy; override;

    function ItemsToJSON: string;
    function GetItemIndex: Integer;
    procedure SetItemIndex(AIndex: Integer);
    procedure SetItems(AItems: TStringList);
    procedure SetTheme(AValue: string); override;

    property Disabled[i: Integer]: Boolean read GetDisabled write SetDisabled;
    property Selected[i: Integer]: Boolean read GetSelected write SetSelected;
  published
    property AutoComplete: Boolean read FAutoComplete write SetAutoComplete default false;
    property ItemIndex: Integer read GetItemIndex write SetItemIndex default -1;
    property Items: TStringList read FItems write SetItems;
    property MultiSelect: Boolean read FMultiSelect write SetMultiSelect default false;
    property TextHint: string read FTextHint write SetTextHint;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXComboBox = class(TJQXComboBox);

  TJQXDropDownList = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure HandleItemsChanged(Sender: TObject);
    function GetDisabled(AIndex: Integer): Boolean;
    procedure SetDisabled(AIndex: Integer; AValue: Boolean);
    function GetSelected(AIndex: Integer): Boolean;
    procedure SetSelected(AIndex: Integer; AValue: Boolean);
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: Boolean); override;
    procedure SetMultiSelect(AValue: Boolean);
    procedure SetTextHint(AValue: string);
  public
    procedure CreateInitialize; override;
    destructor Destroy; override;

    function ItemsToJSON: string;
    function GetItemIndex: Integer;
    procedure SetItemIndex(AIndex: Integer);
    procedure SetItems(AItems: TStringList);
    procedure SetTheme(AValue: string); override;

    property Disabled[i: Integer]: Boolean read GetDisabled write SetDisabled;
    property Selected[i: Integer]: Boolean read GetSelected write SetSelected;
  published
    property ItemIndex: Integer read GetItemIndex write SetItemIndex default -1;
    property Items: TStringList read FItems write SetItems;
    property MultiSelect: Boolean read FMultiSelect write SetMultiSelect default false;
    property TextHint: string read FTextHint write SetTextHint;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXDropDownList = class(TJQXDropDownList);

  TJQXNumberInput = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;

    function GetValue: Double;
    procedure SetDigits(AValue: Integer);
    procedure SetDecimalDigits(AValue: Integer);
    procedure SetInputMode(AValue: TJQXInputMode);
    procedure SetMaxValue(AValue: Double);
    procedure SetMinValue(AValue: Double);
    procedure SetShowSpinButtons(AValue: Boolean);
    procedure SetSpinButtonsStep(AValue: Integer);
    procedure SetSymbol(AValue: string);
    procedure SetSymbolPosition(AValue: TJQXSymbolPosition);
    procedure SetValue(AValue: Double);
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property Digits: Integer read FDigits write SetDigits;
    property DecimalDigits: Integer read FDecimalDigits write SetDecimalDigits;
    property InputMode: TJQXInputMode read FInputMode write SetInputMode;
    property MaxValue: Double read FMaxValue write SetMaxValue;
    property MinValue: Double read FMinValue write SetMinValue;
    property ShowSpinButtons: Boolean read FShowSpinButtons write SetShowSpinButtons;
    property SpinButtonsStep: Integer read FSpinButtonsStep write SetSpinButtonsStep;
    property Symbol: String read FSymbol write SetSymbol;
    property SymbolPosition: TJQXSymbolPosition read FSymbolPosition write SetSymbolPosition;
    property Value: Double read GetValue write SetValue;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXNumberInput = class(TJQXNumberInput);

  TJQXRating = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;

    function GetValue: Double;
    procedure SetItemCount(AValue: Integer);
    //procedure SetPrecision(AValue: TJQXRatingPrecision);
    procedure SetValue(AValue: Double);
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
  public
    procedure CreateInitialize; override;
  published
    property ItemCount: Integer read FItemCount write SetItemCount;
    //property Precision: TJQXRatingPrecision read FPrecision write SetPrecision;
    property Value: Double read GetValue write SetValue;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXRating = class(TJQXRating);

  TJQXButton = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetTop(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property Caption: string read FCaption write SetCaption;
    property CaptionPosition: TJQXPosition read FCaptionPosition write SetCaptionPosition default xpLeft;
    property CaptionImageRelation: TJQXImagePosition read FCaptionImageRelation write SetCaptionImageRelation default ipAfterImage;
    property ImageURL: string read FImageURL write SetImageURL;
    property ImagePosition: TJQXPosition read FImagePosition write SetImagePosition default xpLeft;
    property ImageHeight: Integer read FImageHeight write SetImageHeight default 16;
    property ImageWidth: Integer read FImageWidth write SetImageWidth default 16;
    property RoundedBorders: Boolean read FRoundedBorders write SetRoundedBorders default true;
    property Template: TJQXTemplate read FTemplate write SetTemplate default ttDefault;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
  end;

  TWebJQXButton = class(TJQXButton);

  TJQXButtonGroup = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;
    procedure FixMargin;
    procedure DoItemsChanged(Sender: TObject);
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    procedure SetEnabled(Value: boolean); override;
  public
    procedure CreateInitialize; override;
    destructor Destroy; override;
    procedure SetTheme(AValue: string); override;

    property ButtonSelect[Button: Integer]: Boolean read GetButtonSelect write SetButtonSelect;
  published
    property EnableHover: Boolean read FEnableHover write SetEnableHover default True;
    property Items: TStringList read FItems write SetItems;
    property Mode: TJQXGroupMode read FMode write SetMode default gmDefault;
    property Template: TJQXTemplate read FTemplate write SetTemplate default ttDefault;
    property OnClick: TJQXButtonEvent read FOnClick write FOnClick;
  end;

  TWebJQXButtonGroup = class(TJQXButtonGroup);

  TJQXKnob = class;
  TJQXKnobAppearance = class;

  TJQXKnobLabels = class(TPersistent)
  public
    constructor Create(AOwner: TJQXKnobAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Offset: Integer read FOffset write SetOffset default 88;
    property Step: Integer read FStep write SetStep default 10;
    property Visible: Boolean read FVisible write SetVisible default true;
  end;

  TJQXKnobProgressBar = class(TPersistent)
  public
    constructor Create(AOwner: TJQXKnobAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Color: TColor read FColor write SetColor default clWebSilver;
    property Size: Integer read FSize write SetSize default 9;
    property Offset: Integer read FOffset write SetOffset default 60;
    property BackgroundColor: TColor read FBackgroundColor write SetBackgroundColor default clWebGray;
    property BorderColor: TColor read FBorderColor write SetBorderColor default clWebBlack;
  end;

  TJQXKnobMarks = class(TPersistent)
  public
    constructor Create(AOwner: TJQXKnobAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property ColorRemaining: TColor read FColorRemaining write SetColorRemaining default clGray;
    property BorderColorRemaining: TColor read FBorderColorRemaining write SetBorderColorRemaining default clGray;
    property ColorProgress: TColor read FColorProgress write SetColorProgress default clSilver;
    property BorderColorProgress: TColor read FBorderColorProgress write SetBorderColorProgress default clSilver;
    property MarkType: TJQXKnobMarkType read FMarkType write SetMarkType default mtLine;
    property Offset: Integer read FOffset write SetOffset default 71;
    property Width: Integer read FWidth write SetWidth default 3;
    property Size: Integer read FSize write SetSize default 6;
    property MajorSize: Integer read FMajorSize write SetMajorSize default 9;
    property MajorInterval: Integer read FMajorInterval write SetMajorInterval default 10;
    property MinorInterval: Integer read FMinorInterval write SetMinorInterval default 2;
  end;

  TJQXKnobPointer = class(TPersistent)
  public
    constructor Create(AOwner: TJQXKnobAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property PointerType: TJQXKnobPointerType read FPointerType write SetPointerType default ptArrow;
    property Color: TColor read FColor write SetColor default clGray;
    property BorderColor: TColor read FBorderColor write SetBorderColor default clSilver;
    property Size: Integer read FSize write SetSize default 59;
    property Offset: Integer read FOffset write SetOffset default 49;
    property Visible: Boolean read FVisible write SetVisible default true;
    property Width: Integer read FWidth write SetWidth default 20;
  end;

  TJQXKnobAppearance = class(TPersistent)
  public
    constructor Create(AOwner: TJQXKnob); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Color: TColor read FColor write SetColor default clNone;
    property BorderColor: TColor read FBorderColor write SetBorderColor default clNone;
    property BorderWidth: Integer read FBorderWidth write SetBorderWidth default 1;
    property Labels: TJQXKnobLabels read FLabels write FLabels;
    property ProgressBar: TJQXKnobProgressBar read FProgressBar write FProgressBar;
    property Marks: TJQXKnobMarks read FMarks write FMarks;
    property Pointer: TJQXKnobPointer read FPointer write FPointer;
  end;

  TJQXKnob = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;

    function GetValue: Double;
    procedure SetValue(AValue: Double);
    procedure SetEnabled(Value: boolean); override;
  public
    procedure CreateInitialize; override;
    destructor Destroy; override;
  published
    property Appearance: TJQXKnobAppearance read FAppearance write SetAppearance;
    property Maximum: Integer read FMaximum write SetMaximum default 100;
    property Minimum: Integer read FMinimum write SetMinimum default 0;
    property Step: Integer read FStep write SetStep default 1;
    property Value: Double read GetValue write SetValue;
    property StartAngle: Integer read FStartAngle write SetStartAngle default 120;
    property EndAngle: Integer read FEndAngle write SetEndAngle default 420;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXKnob = class(TJQXKnob);

  TJQXProgressBar = class;
  TJQXProgressBarColors = class;

  TJQXProgressBarColor = class(TCollectionItem)
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  protected
    function GetDisplayName: string; override;
  published
    property Color: TColor read FColor write SetColor;
    property Stop: Integer read FStop write SetStop;
  end;

  TJQXProgressBarColors = class(TCollection)
  protected
    procedure Update(Item: TCollectionItem); override;
  public
    constructor Create(AOwner: TJQXProgressBar); overload;
    function GetOwner: TPersistent; override;
    function Add: TJQXProgressBarColor; reintroduce;
    function Insert(Index: Integer):TJQXProgressBarColor; reintroduce;
    property Items[Index: Integer]: TJQXProgressBarColor read GetItems write SetItems; default;
  end;

  TJQXProgressBar = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    function ColorsToArray: TJSArray;

    procedure SetValue(AValue: Integer);
    procedure SetEnabled(Value: boolean); override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
  public
    procedure CreateInitialize; override;
    destructor Destroy; override;
    procedure SetTheme(AValue: string); override;
  published
    property AnimationDuration: Integer read FAnimationDuration write SetAnimationDuration default 300;
    property ColorRanges: TJQXProgressBarColors read FColorRanges write SetColorRanges;
    property Maximum: Integer read FMaximum write SetMaximum default 100;
    property Minimum: Integer read FMinimum write SetMinimum default 0;
    property Value: Integer read FValue write SetValue;
    property ShowValue: Boolean read FShowValue write SetShowValue default True;
    property Template: TJQXTemplate read FTemplate write SetTemplate default ttDefault;
    property Orientation: TJQXProgressOrientation read FOrientation write SetOrientation default poHorizontal;
    property Layout: TJQXProgressLayout read FLayout write SetLayout default plNormal;
  end;

  TWebJQXProgressBar = class(TJQXProgressBar);

  TJQXSlider = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure UpdateSize;
    procedure BindEvents; override;

    function GetValue: Double;
    procedure SetValue(AValue: Double);
    procedure SetEnabled(Value: boolean); override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property ButtonsPosition: TJQXHorizontalPosition read FButtonsPosition write SetButtonsPosition default hpBoth;
    property TicksPosition: TJQXVerticalPosition read FTicksPosition write SetTicksPosition default vpBoth;
    property TicksFrequency: Integer read FTicksFrequency write SetTicksFrequency default 2;
    property TickSize: Integer read FTickSize write SetTickSize default 5;
    property MinorTicksFrequency: Integer read FMinorTicksFrequency write SetMinorTicksFrequency default 2;
    property MinorTickSize: Integer read FMinorTickSize write SetMinorTickSize default 5;
    property ShowButtons: Boolean read FShowButtons write SetShowButtons default true;
    property ShowTicks: Boolean read FShowTicks write SetShowTicks default true;
    property ShowMinorTicks: Boolean read FShowMinorTicks write SetShowMinorTicks default true;
    property ShowRange: Boolean read FShowRange write SetShowRange default true;
    property ShowRangeSlider: Boolean read FShowRangeSlider write SetShowRangeSlider default false;
    property MaximumValue: Double read GetMaximumValue write SetMaximumValue default 10;
    property MinimumValue: Double read GetMinimumValue write SetMinimumValue default 0;
    property Maximum: Double read FMaximum write SetMaximum default 10;
    property Minimum: Double read FMinimum write SetMinimum default 0;
    property Mode: TJQXSliderMode read FMode write SetMode default smDefault;
    property Step: Double read FStep write SetStep default 2;
    property Template: TJQXTemplate read FTemplate write SetTemplate default ttDefault;
    property Layout: TJQXProgressLayout read FLayout write SetLayout default plNormal;
    property Value: Double read GetValue write SetValue;
    property OnChange: TJQXSliderEvent read FOnChange write FOnChange;
  end;

  TWebJQXSlider = class(TJQXSlider);

  TJQXRangeSelector = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;

    procedure SetEnabled(Value: boolean); override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property MaximumValue: Double read GetMaximumValue write SetMaximumValue default 10;
    property MinimumValue: Double read GetMinimumValue write SetMinimumValue default 0;
    property Maximum: Double read FMaximum write SetMaximum default 10;
    property Minimum: Double read FMinimum write SetMinimum default 0;
    property MajorTicksInterval: Integer read FMajorTicksInterval write SetMajorTicksInterval default 5;
    property MinorTicksInterval: Integer read FMinorTicksInterval write SetMinorTicksInterval default 1;
    property MoveOnClick: Boolean read FMoveOnClick write SetMoveOnClick default True;
    property Resizable: Boolean read FResizable write SetResizable default True;
    property ShowMajorTicks: Boolean read FShowMajorTicks write SetShowMajorTicks default True;
    property ShowMinorTicks: Boolean read FShowMinorTicks write SetShowMinorTicks default True;
    property ShowMarkers: Boolean read FShowMarkers write SetShowMarkers default True;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TWebJQXRangeSelector = class(TJQXRangeSelector);

  TJQXTagCloud = class;
  TJQXCloudTags = class;

  TJQXCloudTag = class(TCollectionItem)
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  protected
    function GetDisplayName: string; override;
  published
    property Tag: Integer read FTag write FTag;
    property TagLabel: String read FTagLabel write SetTagLabel;
    property TagName: String read FTagName write SetTagName;
    property TagValue: Integer read FTagValue write SetTagValue;
  end;

  TJQXCloudTags = class(TCollection)
  protected
    procedure Update(Item: TCollectionItem); override;
  public
    constructor Create(AOwner: TJQXTagCloud); overload;
    function GetOwner: TPersistent; override;
    function Add: TJQXCloudTag; reintroduce;
    function Insert(Index: Integer):TJQXCloudTag; reintroduce;
    property Items[Index: Integer]: TJQXCloudTag read GetItems write SetItems; default;
  end;

  TJQXTagCloud = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;

    procedure SetEnabled(Value: boolean); override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
    function DataToArray: TJSArray;
    function HandleItemClick(Event: TJQXEvent): boolean; virtual;
  public
    procedure CreateInitialize; override;
    destructor Destroy; override;
  published
    property DisplayLimit: Integer read FDisplayLimit write SetDisplayLimit default -1;
    property DisplayTopWeighted: Boolean read FDisplayTopWeighted write SetDisplayTopWeighted default False;
    property DisplayMaxValue: Integer read FDisplayMaxValue write SetDisplayMaxValue default -1;
    property DisplayMinValue: Integer read FDisplayMinValue write SetDisplayMinValue default -1;
    property Items: TJQXCloudTags read FItems write FItems;
    property MaxColor: TColor read FMaxColor write SetMaxColor default clNone;
    property MinColor: TColor read FMinColor write SetMinColor default clNone;
    property MaxFontSize: Integer read FMaxFontSize write SetMaxFontSize default 36;
    property MinFontSize: Integer read FMinFontSize write SetMinFontSize default 8;
    property SortBy: TJQXTagCloudSort read FSortBy write SetSortBy default tcsNone;
    property SortOrder: TJQXSortOrder read FSortOrder write SetSortOrder default soAscending;
    property TextCase: TJQXTextCase read FTextCase write SetTextCase default tcOriginal;
    property OnClick: TJQXTagEvent read FOnClick write FOnClick;
  end;

  TWebJQXTagCloud = class(TJQXTagCloud);

  TJQXResponsivePanel = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;
    function GetContentID: string;
    function GetButtonID: string;
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
    procedure SetEnabled(Value: boolean); override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;

    procedure Open;
    procedure Close;
    procedure Refresh;
  published
    property AnimationType: TJQXAnimationType read FAnimationType write SetAnimationType default atNone;
    property AutoClose: Boolean read FAutoClose write SetAutoClose default True;
    property CollapseBreakPoint: Integer read FCollapseBreakPoint write SetCollapsBreakPoint default 1000;
    property ToggleButtonSize: Integer read FToggleButtonSize write SetToggleButtonSize default 30;

    property OnOpen: TNotifyEvent read FOnOpen write FOnOpen;
    property OnClose: TNotifyEvent read FOnClose write FOnClose;
    property OnCollapse: TNotifyEvent read FOnCollapse write FOnCollapse;
    property OnExpand: TNotifyEvent read FOnExpand write FOnExpand;
  end;

  TWebJQXResponsivePanel = class(TJQXResponsivePanel);

  TJQXTabSheet = class(TDivPanel)
  protected
    procedure BindEvents; override;
  public
    procedure CreateInitialize; override;
  published
    property Caption: string read FCaption write FCaption;
  end;

  TWebJQXTabSheet = class(TJQXTabSheet);

  TJQXTabs = class(TJQXCustomControl)
  protected
    procedure InitJQuery; override;
    procedure UpdateElement; override;
    procedure BindEvents; override;
    procedure SetEnabled(Value: boolean); override;
    procedure SetWidth(AValue: Integer); override;
    procedure SetHeight(AValue: Integer); override;
  public
    procedure CreateInitialize; override;
    procedure SetTheme(AValue: string); override;
  published
    property Collapsible: Boolean read FCollapsible write SetCollapsible default False;
    property EnableHover: Boolean read FEnableHover write SetEnableHover default True;
    property EnableScrollAnimation: Boolean read FEnableScrollAnimation write SetEnableScrollAnimation default True;
    property Position: TJQXTabPosition read FPosition write SetPosition default tpTop;
    property Reorder: Boolean read FReorder write SetReorder default False;
    property SelectionTracker: Boolean read FSelectionTracker write SetSelectionTracker default False;
    property ScrollPosition: TJQXHorizontalPosition read FScrollPosition write SetScrollPosition default hpRight;
    property ScrollStep: Integer read FScrollStep write SetScrollStep default 70;
    property ToggleMode: TJQXToggleMode read FToggleMode write SetToggleMode default tmClick;
    property TabIndex: Integer read GetTabIndex write SetTabIndex default 0;

    property OnTabClick: TJQXTabEvent read FOnTabClick write FOnTabClick;
    property OnSelected: TJQXTabEvent read FOnSelected write FOnSelected;
  end;

  TWebJQXTabs = class(TJQXTabs);

implementation
end.
