{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018 - 2021                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.LocalFiles;

interface

uses
  Classes, SysUtils, JS, Web;

type
  TOpenTextFileProc = reference to procedure(AText: string);
  TOpenBinaryFileProc = reference to procedure(AValue: TJSArrayBuffer);

  TSaveFileProc = reference to procedure;

  TTextFile = class(TObject)
  protected
    procedure DoOpenFile(AHandle: JSValue; Value: string; AOpenFile: TOpenTextFileProc);
    procedure DoSaveFile(ASaveFile: TSaveFileProc);
    procedure DoSaveAsFile(AHandle: JSValue; ASaveFile: TSaveFileProc);
  public
    constructor Create;
    property FileHandle: JSValue read FFileHandle write FFileHandle;
    procedure OpenFile; overload;
    procedure OpenFile(AOpenFile: TOpenTextFileProc); overload;
    procedure SaveFile; overload;
    procedure SaveFile(ASaveFile: TSaveFileProc); overload;
    procedure SaveAsFile; overload;
    procedure SaveAsFile(ASaveFile: TSaveFileProc); overload;
    property Text: string read FText write FText;
    property FileName: string read FFileName;
  published
    property OnFileOpen: TNotifyEvent read FOnFileOpen write FOnFileOpen;
    property OnFileSave: TNotifyEvent read FOnFileSave write FOnFileSave;
  end;

  TBinaryFile = class(TObject)
  protected
    procedure DoOpenFile(AHandle: JSValue; Value: TJSArrayBuffer; AOpenFile: TOpenBinaryFileProc);
    procedure DoSaveFile(ASaveFile: TSaveFileProc);
    procedure DoSaveAsFile(AHandle: JSValue; ASaveFile: TSaveFileProc);
  public
    constructor Create;
    property FileHandle: JSValue read FFileHandle write FFileHandle;
    procedure OpenFile; overload;
    procedure OpenFile(AOpenFile: TOpenBinaryFileProc); overload;
    procedure SaveFile; overload;
    procedure SaveFile(ASaveFile: TSaveFileProc); overload;
    procedure SaveAsFile; overload;
    procedure SaveAsFile(ASaveFile: TSaveFileProc); overload;
    property Data: TJSArrayBuffer read FData write FData;
    property FileName: string read FFileName;
  published
    property OnFileOpen: TNotifyEvent read FOnFileOpen write FOnFileOpen;
    property OnFileSave: TNotifyEvent read FOnFileSave write FOnFileSave;
  end;

  TFileSystemFileHandle = record
    Kind: string;
    Name: string;
  end;

  TFileSystemFolderHandle = JSValue;

  TFileHandle = record
    Name: string;
    Lastmodfieddate: string;
    Size: longint;
    Fileobject: JSValue;
  end;

  TFileSystemFileHandleArray = array of TFileSystemFileHandle;

  TOpenFolderProc = reference to procedure;

  TGetFileProc = reference to procedure(AFileHandle: TFileHandle);
  TGetFolderProc = reference to procedure(AFolderHandle: TFileSystemFolderHandle);

  TFolder = class(TObject)
  protected
    procedure DoGetFile(AFileHandle: JSValue; AProc: TGetFileProc);
    procedure DoListFile(AFile: JSValue);
    procedure DoGetFolder(AFolder: TFileSystemFileHandle);
    procedure DoOpenFolder(AOpenFolder: TOpenFolderProc);
    procedure DoGetFolderHandle(AFolder: TFileSystemFolderHandle; GetFolder: TGetFolderProc);
  public
    constructor Create(AFolderHandle: JSValue); overload;
    constructor Create; overload;
    procedure Open; overload;
    procedure Open(AOpenFolder: TOpenFolderProc); overload;
    procedure CreateFolder(AName: string);
    procedure CreateFile(AName: string);
    procedure GetFile(AName: string; GetFile: TGetFileProc);
    procedure GetFolder(AName: string; GetFolder: TGetFolderProc);
    property Files: TFileSystemFileHandleArray read FFileArray;
  published
    property OnFolderOpen: TNotifyEvent read FOnFolderOpen write FOnFolderOpen;
  end;

implementation
end.
