{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018 - 2019                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.SignIn;

interface

uses
  Classes, Web, JS, WEBLib.Controls, WEBLib.Graphics;

const
  MAJ_VER = 1; // Major version nr.
  MIN_VER = 0; // Minor version nr.
  REL_VER = 1; // Release nr.
  BLD_VER = 0; // Build nr.

  // version history
  // 1.0.0.0 : First release
  // 1.0.1.0 : Facebook Profile Image added

type
  TGoogleSignedInEventArgs = class(TPersistent)
  public
    property Token: string read FToken write FToken;
    property ID: string read FID write FID;
    property FirstName: string read FFirstName write FFirstName;
    property LastName: string read FLastName write FLastName;
    property ImageUrl: string read FImageUrl write FImageUrl;
    property EMail: string read FEMail write FEMail;
  end;

  TGoogleSignedInEvent = procedure(Sender: TObject; Args: TGoogleSignedInEventArgs) of object;

  TFacebookSignedInEventArgs = class(TPersistent)
  public
    property ID: string read FID write FID;
    property Name: string read FName write FName;
    property Email: string read FEmail write FEmail;
    property ImageUrl: string read FImageUrl write FImageUrl;
  end;

  TFacebookSignedInEvent = procedure(Sender: TObject; Args: TFacebookSignedInEventArgs) of object;

  TSignInServiceType = (stGoogle, stFacebook);

  TSignInService = class(TPersistent)
  public
    constructor Create; reintroduce;
    destructor Destroy; override;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    procedure Assign(Source: TPersistent); override;
  published
    property Enabled: Boolean read FEnabled write SetEnabled default True;
    property Visible: Boolean read FVisible write SetVisible default True;
    property AppKey: string read FAppKey write SetAppKey;
    property ControlID: string read FControlID write SetControlID;
  end;

  TSignInServices = class(TPersistent)
  protected
    procedure DoServiceChanged(Sender: TObject);
  public
    constructor Create; reintroduce;
    destructor Destroy; override;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    procedure Assign(Source: TPersistent); override;
  published
    property Google: TSignInService read FGoogle write SetGoogle;
    property Facebook: TSignInService read FFacebook write SetFacebook;
  end;

  TSignIn = class(TCustomControl)
  protected
    function CreateElement: TJSElement; override;
    procedure UpdateElement; override;
    procedure AddScript(Script: string);
    procedure AddMetaTag(Name, Content: string);
    procedure DoServicesChanged(Sender: TObject);
    function HandleGoogleSignIn(GoogleUser: TJSObject): Boolean;
    function HandleGoogleSignOut: Boolean;
    function HandleFacebookSignIn(Event: JSValue): Boolean;
    function HandleFacebookSignOut: Boolean;
  public
    destructor Destroy; override;
    procedure SignIn(Service: TSignInServiceType);
    procedure SignOut(Service: TSignInServiceType);
    procedure CreateInitialize; override;
  published
    property Enabled;
    property ElementClassName;
    property ElementID;

    property Services: TSignInServices read FServices write SetServices;

    property OnGoogleSignedIn: TGoogleSignedInEvent read FOnGoogleSignedIn write FOnGoogleSignedIn;
    property OnGoogleSignedOut: TNotifyEvent read FOnGoogleSignedOut write FOnGoogleSignedOut;
    property OnFacebookSignedIn: TFacebookSignedInEvent read FOnFacebookSignedIn write FOnFacebookSignedIn;
    property OnFacebookSignedOut: TNotifyEvent read FOnFacebookSignedOut write FOnFacebookSignedOut;
  end;


implementation
end.


