{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright  2018 - 2020                                 }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

{$mode objfpc}
{$modeswitch externalclass}

unit WEBLib.WebSocketClient;

{$DEFINE NOPP}

interface

uses
  Classes, JS, web, WEBLib.Controls;

const
  DefaultPort = 8888;

type
  TSocketClientDataReceivedEvent = procedure(Sender: TObject; Origin: string; SocketData: TJSObjectRecord) of object;

  TSocketClient = class(TComponent)
  protected
    procedure CreateWebSockets;
    procedure DoMessage(AEvent: TJSMessageEvent);
    procedure DoOpen(AEvent: TJSEvent);
    procedure DoClose(AEvent: TJSEvent);
  public
    constructor Create(AOwner: TComponent); overload; override;
    constructor Create(AOwner: TComponent; APort: Integer); reintroduce; overload; virtual;
    constructor Create(AOwner: TComponent; AHostName: string; APort: Integer); reintroduce; overload; virtual;
    constructor Create(AOwner: TComponent; AHostName: string; APathName: string; APort: Integer); reintroduce; overload; virtual;
    function GetDefaultHostName: string; virtual;
    function GetDefaultPort: Integer; virtual;
    function GetDefaultPathName: string; virtual;
    function SupportsWebSockets: Boolean; virtual;
    function GetDefaultProtocol: string; virtual;
    function GetWebSocketPath: string; virtual;
    procedure Connect;
    procedure Send(const AMessage: string); overload;
    procedure Send(AMessage: TJSArrayBuffer); overload;
    procedure Disconnect;
  published
    property Port: Integer read FPort write FPort default DefaultPort;
    property HostName: string read FHostName write FHostName;
    property PathName: string read FPathName write FPathName;
    property OnConnect: TNotifyEvent read FOnConnect write FOnConnect;
    property OnDisconnect: TNotifyEvent read FOnDisconnect write FOnDisconnect;
    property OnDataReceived: TSocketClientDataReceivedEvent read FOnDataReceived write FOnDataReceived;
  end;

  TWebSocketClient = class(TSocketClient);

implementation
end.
