{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}
unit WEBLib.myCloudData;

{$DEFINE NOPP}

interface

uses
  Classes, WebLib.REST, JS, SysUtils;

type
  TmyCloudDataMetaData = class;
  TmyCloudDataEntity = class;
  TmyCloudDataEntities = class;
  TmyCloudDataTable = class;
  TmyCloudData = class;

  TmyCloudDataTable = class(TCollectionItem)
  protected
    procedure HandleGetMetaData(Sender: TObject; AResponse: string; var Handled: boolean);
    procedure HandleGetEntities(Sender: TObject; AResponse: string; var Handled: boolean);
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure GetMetaData;
    procedure GetEntities;

    property MetaData: TmyCloudDataMetaData read FMetaData;
    property Entities: TmyCloudDataEntities read FEntities;
  published
    property TableName: string read FTableName write FTableName;
    property TableID: string read FTableID write FTableID;
    property OnMetaData: TNotifyEvent read FOnMetaData write FOnMetaData;
    property OnEntities: TNotifyEvent read FOnEntities write FOnEntities;
  end;

  TmyCloudDataTables = class(TOwnedCollection)
  public
    constructor Create(AOwner: TPersistent); reintroduce;
    function Add: TmyCloudDataTable; reintroduce;
    function Insert(Index: integer): TmyCloudDataTable; reintroduce;
    property Items[Index: integer]: TmyCloudDataTable read GetItem write SetItem;
  end;


  TFieldType = (ftUnknown, ftString, ftSmallint, ftInteger, ftWord, // 0..4
    ftBoolean, ftFloat, ftCurrency, ftBCD, ftDate, ftTime, ftDateTime, // 5..11
    ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo, ftGraphic, ftFmtMemo, // 12..18
    ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor, ftFixedChar, ftWideString, // 19..24
    ftLargeint, ftADT, ftArray, ftReference, ftDataSet, ftOraBlob, ftOraClob, // 25..31
    ftVariant, ftInterface, ftIDispatch, ftGuid, ftTimeStamp, ftFMTBcd, // 32..37
    ftFixedWideChar, ftWideMemo, ftOraTimeStamp, ftOraInterval, // 38..41
    ftLongWord, ftShortint, ftByte, ftExtended, ftConnection, ftParams, ftStream, //42..48
    ftTimeStampOffset, ftObject, ftSingle); //49..51

  TFieldTypes = set of TFieldType;


  TMyCloudDataMetaDataTypedField = (tfNone, tfRadioButton, tfComboBox, tfCheckBox);

  TMyCloudDataMetaDataItem = class(TCollectionItem)
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    property Size: integer read FSize;
    property DataType: TFieldType read FDataType;
  published
    property FieldName: string read FFieldName write FFieldName;
    property LabelText: string read FLabelText write FLabelText;
    property DefaultValue: string read FDefaultValue write FDefaultValue;
    property Width: integer read FWidth write FWidth;
    property Order: integer read FOrder write FOrder;
    property Mask: string read FMask write FMask;
    property Minimum: double read FMinimum write FMinimum;
    property Maximum: double read FMaximum write FMaximum;
    property MinimumDate: TDateTime read FMinimumDate write FMinimumDate;
    property MaximumDate: TDateTime read FMaximumDate write FMaximumDate;
    property Visible: boolean read FVisible write FVisible default true;
    property Enabled: boolean read FEnabled write FEnabled default true;
    property Required: boolean read FRequired write FRequired default false;
    property Description: string read FDescription write FDescription;
    property LookupTable: int64 read FLookupTable write FLookupTable;
    property LookupField: string read FLookupField write FLookupField;
    property LookupKeyField: string read FLookupKeyField write FLookupKeyField;
    property TypedField: TMyCloudDataMetaDataTypedField read FTypedField write FTypedField;
  end;

  TMyCloudDataMetaData = class(TOwnedCollection)
  public
    constructor Create(AOwner: TPersistent); reintroduce;
    function Add: TMyCloudDataMetaDataItem; reintroduce; overload;
    function Add(PropertyName: string; DataType: TFieldType; Size: integer = 0): TMyCloudDataMetaDataItem; overload;
    function Insert(Index: Integer): TMyCloudDataMetaDataItem; reintroduce;
    property Items[Index: Integer]: TMyCloudDataMetaDataItem read GetItems write SetItems; default;
    function GetMetaDataItemByName(AName: string): TMyCloudDataMetaDataItem;
  end;

  TMyCloudDataBlob = class(TPersistent)
  public
    //constructor Create(ADataStore: TCustomDataStore);
    property Table: TMyCloudDataTable read FTable write FTable;
    property Entity: TMyCloudDataEntity read FEntity write FEntity;
    property Field: string read FField write FField;

    //function LoadFromFile(AFileName: string): boolean;
    //function SaveToFile(AFileName: string): boolean;
    //function LoadFromStream(AStream: TStream): boolean;
    //function SaveToStream(AStream: TStream): boolean;
  end;

  TmyCloudDataEntity = class(TCollectionItem)
  protected
    procedure HandleInsert(Sender: TObject; AResponse: string; var Handled: boolean);
    procedure HandleDelete(Sender: TObject; AResponse: string; var Handled: boolean);
    procedure HandleUpdate(Sender: TObject; AResponse: string; var Handled: boolean);

    property Table: TMyCloudDataTable read FTable write FTable;
    property Values: TStringList read FValues;
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    //procedure FromJSON(jo: TJSONObject); override;
    property Value[AName: string]: string read GetValue write SetValue;
    property Blob[AName: string]: TMyCloudDataBlob read GetBlob;
    function Update: boolean;
    function Insert: boolean;
    function Delete: boolean;
    property IntID: int64 read GetIntID;
    property ID: string read FID write FID;
  published
    property OnInsert: TNotifyEvent read FOnInsert write FOnInsert;
    property OnUpdate: TNotifyEvent read FOnUpdate write FOnUpdate;
    property OnDelete: TNotifyEvent read FOnDelete write FOnDelete;
  end;

  TmyCloudDataEntities = class(TOwnedCollection)
  protected
    property Table: TMyCloudDataTable read FTable write FTable;
  public
    constructor Create(AOwner: TPersistent); reintroduce;
    function Add: TMyCloudDataEntity; reintroduce;
    function Insert(Index: Integer): TMyCloudDataEntity; reintroduce;
    property Items[Index: Integer]: TMyCloudDataEntity read GetItems write SetItems; default;
  end;

  TmyCloudData = class(TRESTClient)
  protected
    procedure HandleTestTokens(Sender: TObject; AResponse: string; var Handled: boolean);
    procedure HandleGetTables(Sender: TObject; AResponse: string; var Handled: boolean);
    function GetAuthURL: string; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure TestTokens; override;
    procedure GetTables;
    property Tables: TmyCloudDataTables read FTables write SetTables;
    property OnTables: TNotifyEvent read FOnTables write FOnTables;
  end;

  TWebmyCloudData = class(TmyCloudData);

implementation
end.
