{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
unit libelectron;

interface

{$mode objfpc}
{$modeswitch externalclass}

uses
  JS, Classes, SysUtils, Web, Types, nodejs;

type
  TBrowserWindow = class;
  TWebContentsEventHandler = reference to procedure(event: TJSEvent; args: JSValue);
  TWebContentsEventArgsHandler = reference to procedure(event: TJSEvent; argf: JSValue; args: JSValue);
  TTrayIconClickEventHandler = reference to procedure;

  TJSElectronStringDynArray = array of string;

  TWebContents = class external name 'webContents' (TJSObject)
  public
    procedure closeDevTools;
    procedure copy;
    procedure copyImageAt(X, Y: NativeInt);
    procedure cut;
    procedure delete;
    procedure downloadURL(aURL: string);
    procedure focus;
    procedure goBack;
    procedure goForward;
    function insertText(Text: string): TJSPromise;
    function loadFile(aFilePath: string): TJSPromise;
    function loadURL(aURL: string): TJSPromise;
    procedure &on(aChannel: string; aListener: TWebContentsEventHandler); overload;
    procedure &on(aChannel: string; aListener: TWebContentsEventArgsHandler); overload;
    procedure openDevTools;
    procedure paste;
    procedure redo;
    procedure reload;
    procedure replace(Text: string);
    procedure replaceMisspelling(Text: string);
    procedure selectAll;
    procedure send(aChannel: string); overload;
    procedure send(aChannel: string; aArgs: JSValue); overload;
    procedure send(aChannel: string; aArgf: JSValue; aArgs: JSValue); overload;
    procedure startDrag(aItem: TJSObject);
    procedure stop;
    procedure undo;
    procedure unselect;
    procedure toggleDevTools;
    function getURL: string;
    function getTitle: string;
    function isDestroyed: Boolean;
    function isFocused: Boolean;
    function isLoading: Boolean;
    property id: Integer read FId write FId;
  end;

  TBrowserWindow = class external name 'BrowserWindow' (TJSObject)
  public
    procedure blur;
    procedure close;
    procedure destroy; reintroduce;
    procedure focus;
    procedure hide;
    function loadURL(aURL: string): TJSPromise;
    function loadFile(aFilePath: string): TJSPromise;
    procedure setAlwaysOnTop(aFlag: Boolean);
    procedure setContentSize(aWidth: NativeInt; aHeight: NativeInt);
    procedure setEnabled(aEnable: Boolean);
    procedure setFullScreen(aFlag: Boolean);
    procedure setKiosk(aFlag: Boolean);
    procedure setMaximumSize(aWidth: NativeInt; aHeight: NativeInt);
    procedure setMinimumSize(aWidth: NativeInt; aHeight: NativeInt);
    procedure setSize(aWidth: NativeInt; aHeight: NativeInt);
    procedure setSkipTaskbar(aSkip: Boolean);
    procedure setTitle(aTitle: string);
    procedure show;
    function fromId(aId: NativeInt): TBrowserWindow;
    function getAllWindows: TJSObjectDynArray;
    function getFocusedWindow: TBrowserWindow;
    function getMaximumSize: TJSArray;
    function getMinimumSize: TJSArray;
    function getParentWindow: TBrowserWindow;
    function getSize: TJSArray;
    function getTitle: string;
    function isAlwaysOnTop: Boolean;
    function isFocused: Boolean;
    function isFullScreen: Boolean;
    function isKiosk: Boolean;
    function isVisible: Boolean;
    property fullScreenable: Boolean read FFullScreenable write FFullScreenable;
    property id: Integer read FId write FId;
    property resizable: Boolean read FResizable write FResizable;
    property webContents: TWebContents read FWebContents write FWebContents;
  end;

  TIPCEvent = class external name 'Event' (TJSObject)
  public
    property returnValue: JSValue read FReturnValue write FReturnValue;
    property sender: TWebContents read FSender;
  end;

  TIPCEventHandler = reference to procedure(event: TIPCEvent; args: JSValue);
  TIPCEventArgsHandler = reference to procedure(event: TIPCEvent; argf: JSValue; args: JSValue);

  TIPCMain = class external name 'ipcMain'
    procedure &on(aChannel: string; aListener: TIPCEventHandler); overload;
    procedure &on(aChannel: string; aListener: TIPCEventArgsHandler); overload;
    procedure once(aChannel: string; aListener: TIPCEventHandler); overload;
    procedure once(aChannel: string; aListener: TIPCEventArgsHandler); overload;
    procedure removeAllListeners; overload;
    procedure removeAllListeners(aChannel: string); overload;
    procedure removeListener(aChannel: string; aListener: TIPCEventHandler); overload;
    procedure removeListener(aChannel: string; aListener: TIPCEventArgsHandler); overload;
  end;

  TIPCRenderer = class external name 'ipcRenderer'
    function invoke(aChannel: string): TJSPromise; overload;
    function invoke(aChannel: string; aArgs: JSValue): TJSPromise; overload;
    procedure &on(aChannel: string; aListener: TIPCEventHandler); overload;
    procedure &on(aChannel: string; aListener: TIPCEventArgsHandler); overload;
    procedure once(aChannel: string; aListener: TIPCEventHandler); overload;
    procedure once(aChannel: string; aListener: TIPCEventArgsHandler); overload;
    procedure removeAllListeners(aChannel: string); overload;
    procedure removeListener(aChannel: string; aListener: TIPCEventHandler); overload;
    procedure removeListener(aChannel: string; aListener: TIPCEventArgsHandler); overload;
    procedure send(aChannel: string); overload;
    procedure send(aChannel: string; aArgs: JSValue); overload;
    procedure send(aChannel: string; aArgf: JSValue; aArgs: JSValue); overload;
    procedure sendTo(aWebContentsID: NativeInt; aChannel: string); overload;
    procedure sendTo(aWebContentsID: NativeInt; aChannel: string; aArgs: JSValue); overload;
  end;

  TSelectOpenFileCallBack = reference to procedure (fileNames: TJSElectronStringDynArray);
  TSelectSaveFileCallBack = reference to procedure (fileName: String);
  TSelectMessageBoxCallBack = reference to procedure (response: NativeInt; checkboxChecked: Boolean);

  TOpenDialogResult = class(TJSObject)
    canceled: Boolean;
    filePaths: TJSElectronStringDynArray;
  end;

  TSaveDialogResult = class(TJSObject)
    canceled: Boolean;
    filePath: string;
  end;

  TMessageDialogResult = class(TJSObject)
    response: NativeInt;
    checkboxChecked: Boolean;
  end;

  TDialog = class external name 'Dialog' (TJSObject)
    procedure showErrorBox(aTitle: string; aContent: string);
    function showMessageBox(aBrowserWindow: TBrowserWindow; aOptions: TJSObject): TJSPromise; overload;
    function showMessageBox(aOptions: TJSObject): TJSPromise; overload;
    function showMessageBoxSync(aBrowserWindow: TBrowserWindow; aOptions: TJSObject): NativeInt; overload;
    function showMessageBoxSync(aOptions: TJSObject): NativeInt; overload;
    function showOpenDialog(aBrowserWindow: TBrowserWindow; aOptions: TJSObject): TJSPromise; overload;
    function showOpenDialog(aOptions: TJSObject): TJSPromise; overload;
    function showOpenDialogSync(aBrowserWindow: TBrowserWindow; aOptions: TJSObject): TJSElectronStringDynArray; overload;
    function showOpenDialogSync(aOptions: TJSObject): TJSElectronStringDynArray; overload;
    function showSaveDialog(aBrowserWindow: TBrowserWindow; aOptions: TJSObject): TJSPromise; overload;
    function showSaveDialog(aOptions: TJSObject): TJSPromise; overload;
    function showSaveDialogSync(aBrowserWindow: TBrowserWindow; aOptions: TJSObject): string; overload;
    function showSaveDialogSync(aOptions: TJSObject): string; overload;
  end;

  TNativeImageClass = class external name 'NativeImage' (TJSObject)
    function toDataURL: string;
  end;

  TNativeImage = class external name 'NativeImage' (TJSObject)
    function createEmpty: TNativeImageClass;
    function createFromDataURL(aDataURL: string): TNativeImageClass;
    function createFromPath(aPath: string): TNativeImageClass;
  end;

  TClipboard = class external name 'clipboard' (TJSObject)
    procedure clear;
    procedure writeHTML(aMarkup: string);
    procedure writeImage(aImage: TNativeImageClass);
    procedure writeRTF(aText: string);
    procedure writeText(aText: string);
    function availableFormats: TJSElectronStringDynArray;
    function readText: string;
    function readHTML: string;
    function readImage: TNativeImageClass;
    function readRTF: string;
  end;

  TShell = class external name 'shell' (TJSObject)
    procedure beep;
    function moveItemToTrash(aFullPath: string): Boolean;
    function openExternal(aURL: string): Boolean;
    function openItem(aFullPath: string): Boolean;
    function showItemInFolder(aFullPath: string): Boolean;
  end;

  TMenuClass = class;

  TMenuItemClass = class external name 'MenuItem' (TJSObject)
  public
    procedure addEventListener(aName: string; aListener: JSValue);
    procedure click(aMenuItem: TMenuItemClass; aBrowserWindow: TBrowserWindow; aEvent: TJSEvent);
    property Checked: Boolean read FChecked write FChecked;
    property Enabled: Boolean read FEnabled write FEnabled;
    property Id: string read FId write FId;
    property &Label: string read FLabel write FLabel;
    property Role: string read FRole;
    property Submenu: TMenuClass read FSubmenu write FSubmenu;
    property &Type: string read FType;
    property Visible: Boolean read FVisible write FVisible;
  end;

  TMenuClass = class external name 'Menu' (TJSObject)
    procedure append(aMenuItem: TMenuItemClass);
    procedure closePopup; overload;
    procedure closePopup(aBrowserWindow: TBrowserWindow); overload;
    procedure popup(aOptions: TJSObject);
    function getMenuItemById(aId: string): TMenuItemClass;
  end;

  TMenu = class external name 'Menu' (TJSObject)
    procedure setApplicationMenu(aMenu: TMenuClass);
    function getApplicationMenu: TMenuClass;
  end;

  TTrayIcon = class external name 'Tray' (TJSObject)
    procedure destroy; reintroduce;
    procedure &on(aChannel: string; aListener: TTrayIconClickEventHandler);
    procedure setContextMenu(aMenu: TMenuClass);
    procedure setImage(aImage: TNativeImageClass);
    procedure setToolTip(aToolTip: string);
  end;

  TApplication = class external name 'app' (TJSObject)
    procedure quit;
    function getAppPath: string;
    function getPath(aName: string): string;
    function getName: string; //current application's name
    function getLocale: string;
    function isReady: Boolean;
  end;

  TGlobalShortcutCallback = reference to procedure;

  TGlobalShortcut = class external name 'globalShortcut' (TJSObject)
    procedure &register(aAccelerator: string; aCallback: TGlobalShortcutCallback);
    procedure unregister(aAccelerator: string);
    procedure unregisterAll;
    function isRegistered(aAccelerator: string): Boolean;
  end;

  TApp = class external Name 'App' (TJSObject)
  public
    function getCurrentWindow: TBrowserWindow;
    function getCurrentWebContents: TWebContents;
    property Application: TApplication read FApplication;
    property BrowserWindow: TBrowserWindow read FBrowserWindow;
    property Clipboard: TClipboard read FClipboard;
    property Dialog: TDialog read FDialog;
    property GlobalShortcut: TGlobalShortcut read FGlobalShortcut;
    property IPCMain: TIPCMain read FIPCMain;
    property Menu: TMenu read FMenu;
    property MenuItem: TMenuItemClass read FMenuItem;
    property NativeImage: TNativeImage read FNativeImage;
    property Shell: TShell read FShell;
    property TrayIcon: TTrayIcon read FTrayIcon;
  end;

  TElectron = class external Name 'Electron' (TJSObject)
  public
    property App: TApp read FApp;
    property Clipboard: TClipboard read FClipboard;
    property IPCRenderer: TIPCRenderer read FIPCRenderer;
    property NativeImage: TNativeImage read FNativeImage;
    property Shell: TShell read FShell;
  end;

  TFileFilter = class external name 'Object' (TJSObject)
  public
    property Extensions: TJSElectronStringDynArray read FExtensions write FExtensions;
    property Name: string read FName write FName;
  end;

  TFileFilterArray = array of TFileFilter;

  TOpenDialogOptions = class external name 'Object' (TJSObject)
  public
    property ButtonLabel: string read FButtonLabel write FButtonLabel;
    property DefaultPath: string read FDefaultPath write FDefaultPath;
    property Filters: TFileFilterArray read FFilters write FFilters;
    property Properties: TJSElectronStringDynArray read FProperties write FProperties;
    property Title: string read FTitle write FTitle;
  end;

  TSaveDialogOptions = class external name 'Object' (TJSObject)
  public
    property ButtonLabel: string read FButtonLabel write FButtonLabel;
    property DefaultPath: string read FDefaultPath write FDefaultPath;
    property Filters: TFileFilterArray read FFilters write FFilters;
    property Title: string read FTitle write FTitle;
  end;

  TMessageBoxOptions = class external name 'Object' (TJSObject)
  public
    property Buttons: TJSElectronStringDynArray read FButtons write FButtons;
    property CancelId: NativeInt read FCancelId write FCancelId;
    property CheckboxChecked: Boolean read FCheckboxChecked write FCheckboxChecked;
    property CheckboxLabel: string read FCheckboxLabel write FCheckboxLabel;
    property DefaultId: NativeInt read FDefaultId write FDefaultId;
    property Detail: string read FDetail write FDetail;
    property Icon: TNativeImageClass read FIcon write FIcon;
    property &Message: string read FMessage write FMessage;
    property NoLink: Boolean read FNoLink write FNoLink;
    property NormalizeAccessKeys: Boolean read FNormalizeAccessKeys write FNormalizeAccessKeys;
    property Title: string read FTitle write FTitle;
    property &Type: string read FType write FType;
  end;

  TJSElectronFile = class external name 'File' (TJSBlob)
  Public
    property lastModified: NativeInt read FLastModified;
    property lastModifiedDate: TJSDate read FLastModifiedDate;
    property name: string read FName;
    property path: string read FPath;
    property &type: string read FType;
  end;

  TJSElectronFileList = class external name 'FileList' (TJSEventTarget)
  Public
    function item(aIndex: NativeInt): TJSElectronFile;
    property length: NativeInt read FLength;
    property Files[aIndex: NativeInt]: TJSElectronFile read item; default;
  end;

  TJSNotificationPermissionCallBack = procedure(APermission: string) of object;
  TJSNotificationClickEvent = reference to procedure(AEvent: TJSEvent);

  TJSElectronNotification = class external name 'Notification'
    onshow: TJSEventHandler;
    onclick: TJSNotificationClickEvent;
    onclose: TJSEventHandler;
    constructor new(aTitle: string); overload;
    constructor new(aTitle: string; AOptions: TJSObject); overload;
    class function requestPermission: TJSPromise; overload;
    class procedure requestPermission(ACallBack: TJSNotificationPermissionCallBack); overload;
    procedure close;
  end;

  TNodeStat = class external name 'Stats' (TJSObject)
  protected
    FMTime: TJSDate external name 'mtime';
  public
    property mtime: TJSDate read FMtime;
  end;

  TNodeWriteStream = class external name 'WriteStream' (TJSObject)
  end;

  TReadFileCallBack = reference to procedure(err: TJSError; data: string);
  TWriteFileCallBack = reference to procedure(err: TJSError);
  TUnlinkCallBack = reference to procedure(err: TJSError);
  TWatchFileListener = reference to procedure(current: TNodeStat; previous: TNodeStat);

  TNodeFS = class external Name 'Electron' (TJSObject)
    procedure readFile(aPath: string; aCallBack: TReadFileCallBack);
    procedure unlink(aPath: string; aCallback: TUnlinkCallBack);
    procedure unwatchFile(aFileName: string; aListener: TWatchFileListener);
    procedure watchFile(aFileName: string; aListener: TWatchFileListener);
    procedure writeFile(aPath: string; aData: string; aCallBack: TWriteFileCallBack);
    procedure writeFileSync(aPath: string; aData: string);
    function createWriteStream(aPath: string): TNodeWriteStream;
    function existSync(aPath: string): Boolean;
    function readFileSync(aPath: string): TJSObject;
  end;

  TIncomingMessage = class external name 'IncomingMessage' (TJSObject)
    procedure pipe(aDestination: TNodeWriteStream);
  end;

  TGetCallBack = reference to procedure(aResponse: TIncomingMessage);

  TClientRequest = class external name 'ClientRequest' (TJSObject)
  end;

  TNodeHTTP = class external name 'Electron' (TJSObject)
    function get(aURL: string; aCallBack: TGetCallBack): TClientRequest;
  end;

  TNodeHTTPS = class external name 'Electron' (TJSObject)
    function get(aURL: string; aCallBack: TGetCallBack): TClientRequest;
  end;

  TMenuKeyCap = (mkcBkSp, mkcTab, mkcEsc, mkcEnter, mkcSpace, mkcPgUp,
    mkcPgDn, mkcEnd, mkcHome, mkcLeft, mkcUp, mkcRight, mkcDown, mkcIns,
    mkcDel, mkcShift, mkcCtrl, mkcAlt);

var
  MenuKeyCaps: array[TMenuKeyCap] of string = (
    'Backspace', 'Tab', 'Escape', 'Return', 'Space', 'PageUp',
    'PageDown', 'End', 'Home', 'Left', 'Up', 'Right',
    'Down', 'Insert', 'Delete', 'Shift+', 'CommandOrControl+', 'Alt+');

const
  scCommand = $1000;
  scShift = $2000;
  scCtrl = $4000;
  scAlt = $8000;
  scNone = 0;

function Electron: TElectron;
function FS: TNodeFS;
function NodeHTTP: TNodeHTTP;
function NodeHTTPS: TNodeHTTPS;
function isElectron: Boolean;

implementation
initialization
end.
