{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.DreamFactoryCDS;

interface

uses
  {$IFNDEF LCLTMSWEB}
  System.Classes, DB, DBClient, WEBLib.Controls, WEBLib.REST, Web, jsdelphisystem, js, WEBLib.CDS;
  {$ENDIF}
  {$IFDEF LCLTMSWEB}
  Classes, DB, WEBLib.Controls, WEBLib.REST, Web, jsdelphisystem, WEBLib.CDS;
  {$ENDIF}

type
  TDreamFactoryErrorEvent = procedure(Sender: TObject; errCode: Integer; errMsg: String) of object;
  TDreamFactorySignupUserExistsEvent = procedure(Sender: TObject; UserName: String) of object;

  {$IFNDEF LCLTMSWEB}
  [ComponentPlatforms(TMSWebPlatform)]
  {$ENDIF}
  TWebDreamFactoryClientDataset = Class(TWebClientDataSet)
  private
    FTableName, FDreamFactoryURL: String;
    FKeyFieldName, FUserName, FPassword,
    FDbServiceName, FApiKey: String;

    FOnError: TDreamFactoryErrorEvent;
    FOnUserExists: TDreamFactorySignupUserExistsEvent;
  protected
    procedure InternalClose; override;
    procedure InternalHandleException; override;
    procedure InternalInitFieldDefs; override;
    procedure InternalOpen; override;
    function IsCursorOpen: Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh(Force: Boolean=False); 
    procedure AddSortFieldDef(aField: String; isAscending: Boolean);
    procedure ClearSortFieldDefs;
    procedure Login(aUserName, aPassword: String; IsSignUp: Boolean=False);
  published
    property DreamFactoryURL: String read FDreamFactoryURL write FDreamFactoryURL;
    property TableName: String read FTableName write FTableName;
    property KeyFieldName: String read FKeyFieldName write FKeyFieldName;
    property ApiKey: String read FApiKey write FApiKey;
    property DbServiceName: String read FDbServiceName write FDbServiceName;
    property OnError: TDreamFactoryErrorEvent read FOnError write FOnError;
    property OnUserExists: TDreamFactorySignupUserExistsEvent read FOnUserExists write FOnUserExists;

    // Other
    property Active;
    property BeforeOpen;
    property AfterOpen;
    property BeforeClose;
    property AfterClose;
    property BeforeInsert;
    property AfterInsert;
    property BeforeEdit;
    property AfterEdit;
    property BeforePost;
    property AfterPost;
    property BeforeCancel;
    property AfterCancel;
    property BeforeDelete;
    property AfterDelete;
    property BeforeScroll;
    property AfterScroll;
    property OnCalcFields;
    property OnDeleteError;
    property OnEditError;
    property OnFilterRecord;
    property OnNewRecord;
    property OnPostError;
  end;

implementation

procedure TWebDreamFactoryClientDataset.InternalClose;
begin
  //
end;

procedure TWebDreamFactoryClientDataset.InternalHandleException;
begin
  //
end;

procedure TWebDreamFactoryClientDataset.InternalInitFieldDefs;
begin
  //
end;

procedure TWebDreamFactoryClientDataset.InternalOpen;
begin
  //
end;

function TWebDreamFactoryClientDataset.IsCursorOpen: Boolean;
begin
  Result := false;
end;

constructor TWebDreamFactoryClientDataset.Create(AOwner: TComponent);
begin
  inherited;
  FDreamFactoryURL := '';
  FTableName := '';
  FKeyFieldName := '';
  FUserName := '';
  FPassword := '';
  FDbServiceName := '';
  FApiKey := '';
end;

destructor TWebDreamFactoryClientDataset.Destroy;
begin
  inherited;
end;

procedure TWebDreamFactoryClientDataset.refresh(Force: Boolean=False);
begin
end;

procedure TWebDreamFactoryClientDataset.AddSortFieldDef(aField: String; isAscending: Boolean);
begin
end;

procedure TWebDreamFactoryClientDataset.ClearSortFieldDefs;
begin
end;

procedure TWebDreamFactoryClientDataset.Login(aUserName, aPassword: String; IsSignUp: Boolean=False);
begin
end;

end.
