{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit libthreejs;

{$mode objfpc}
{$modeswitch externalclass}

interface

uses
  classes, JS, Web; 

const
  ThreeJsDoubleSide: NativeInt; external name 'THREE.DoubleSide';
  ThreeJsFaceColors: NativeInt; external name 'THREE.FaceColors';
  ThreeJsVertexColors: NativeInt; external name 'THREE.VertexColors';
  ThreeJsFlatShading: NativeInt; external name 'THREE.FlatShadin';
  ThreeJsRepeatWrapping: NativeInt; external name 'THREE.RepeatWrapping';

type
  TColor = type NativeInt;

  TThreeJsVector3 = class external name 'THREE.Vector3' (TJSObject)
  public
    constructor New;
    constructor New(x : Double; y : Double; z : Double);
    // can not use "set" as procedure name, hence doSet
    procedure doSet(x : Double; y : Double; z : Double); external name 'set';
    procedure copy(aTarget: TThreeJsVector3);
    function subVectors(a: TThreeJsVector3; b: TThreeJsVector3): TThreeJsVector3;
    function normalize: TThreeJsVector3;
    function distanceTo(aTarget: TThreeJsVector3): Double;
    property x: Double read fX write fX;
    property y: Double read fY write fY;
    property z: Double read fZ write fZ;
  end;

  TThreeJsVector2 = class external name 'THREE.Vector2' (TJSObject)
  public
    constructor New;
    constructor New(x : Double; y : Double);
    procedure doSet(x : Double; y : Double); external name 'set';
    property x: Double read fX write fX;
    property y: Double read fY write fY;
  end;

  TThreeJsShape = class external name 'THREE.Shape' (TJSObject)
  public
    constructor New;
    procedure moveTo(x, y: double);
    procedure lineTo(x, y: double);
  end;


  TThreeJsEuler = class external name 'THREE.Euler' (TJSObject)
  public
    property x: Double read fX write fX;
    property y: Double read fY write fY;
    property z: Double read fZ write fZ;
  end;

  TThreeJsTexture = class external name 'THREE.Texture' (TJSObject)
  public
    constructor New(anImage: TJSHTMLImageElement);
    property wrapS: integer read fWrapS write fWrapS;
    property wrapT: integer read fWrapT write fWrapT;
    property repeats: TThreeJsVector2 read fRepeat write fRepeat;
    property needsUpdate: boolean read fNeedsUpdate write fNeedsUpdate;
  end;

  TThreeJsTextureLoadEvent = reference to procedure;

  TThreeJsTextureLoader = class external name 'THREE.TextureLoader' (TJSObject)
  public
    function load(aUrl: string; DoOnLoad: TThreeJsTextureLoadEvent): TThreeJsTexture;
  end;

  TThreeJsMaterial = class external name 'THREE.Material' (TJSObject)
  public
    procedure dispose;
    property side: integer read fSide write fSide;
    property needsUpdate: boolean read fNeedsUpdate write fNeedsUpdate;
    property map: TThreeJsTexture read fMap write fMap;
    property bumpMap: TThreeJsTexture read fBumpMap write fBumpMap;
  end;

  TThreeJsLineBasicMaterial = class external name 'THREE.LineBasicMaterial' (TThreeJsMaterial)
  public
    constructor New(parameters: TJSObject);
    property lineWidth: double read flineWidth write flineWidth;
  end;

  TThreeJsColor = class external name 'THREE.Color' (TJSObject)
  public
    constructor New(colorHex: JSValue);
    procedure doSet(colorHex: JSValue); external name 'set';
    procedure setRGB(r: double; g: double; b: double);
    // sets all 3 color components to a value Scalar (0.0 to 1.0)
    procedure setScalar(scalar: double);
    procedure setHex(aColorHex: JSValue);
    function getHex: JSValue;
    procedure setHSL(h: double; s: double; l: double);
  end;

  TThreeJsMeshLambertMaterial = class external name 'THREE.MeshLambertMaterial' (TThreeJsMaterial)
  public
    constructor New(parameters: TJSObject);
    property emissive: TThreeJsColor read fEmissive write fEmissive;
  end;

  TThreeJsMeshStandardMaterial = class external name 'THREE.MeshStandardMaterial' (TThreeJsMaterial)
  public
    constructor New(parameters: TJSObject);
  end;

  TThreeJsMeshBasicMaterial = class external name 'THREE.MeshBasicMaterial' (TThreeJsMaterial)
  public
    constructor New(parameters: TJSObject);
  end;

  TThreeJsMeshLineMaterial = class external name 'MeshLineMaterial' (TThreeJsMaterial)
  public
    constructor New(parameters: TJSObject);
  end;

  TThreeJsFace3 = class external name 'THREE.Face3' (TJSObject)
  public
    property a: integer read fa write fa;
    property b: integer read fb write fb;
    property c: integer read fc write fc;
    property vertexColors: TJSArray read fVertexColors write fVertexColors;
    property faceIndex: integer read fFaceIndex write fFaceIndex;
    property colorHtml: TThreeJsColor read fColor write fColor;
  end;

  TThreeJsFace3Helper = class helper for TThreeJsFace3
  protected
    procedure SetColor(AValue: TColor);
    function GetColor: TColor;
  public
    property Color: TColor read GetColor write SetColor;
  end;

  TThreeJsBox3 = class;

  TThreeJsGeometry = class external name 'THREE.Geometry' (TJSObject)
  public
    constructor New;
    procedure computeBoundingBox;
    procedure dispose;
    property vertices: TJSArray read fVertices write fVertices;
    property faces: TJSArray read fFaces write fFaces;
    property colors: TJSArray read fColors write fColors;
    property boundingbox: TThreeJsBox3 read fBoundingbox write fBoundingbox;
  end;

  TThreeJsObject3D = class external name 'THREE.Object3D' (TJSObject)
  public
    procedure lookAt(aVector: TThreeJsVector3);
    procedure add(anObject: TThreeJsObject3D);
    function getObjectByName(aname: string): TThreeJsObject3D;
    procedure remove(anObject: TThreeJsObject3D);
    property position: TThreeJsVector3 read fPosition write fposition;
    property rotation: TThreeJsEuler read fRotation;
    property castShadow: boolean read fCastShadow write fCastShadow;
    property receiveShadow: boolean read fReceiveShadow write fReceiveShadow;
    property name: string read fName write fName;
    // "type" is reserved work in Delphi so theType
    property theType: string read fType write fType;
    property material: TThreeJsMaterial read fMaterial;
    property line: TThreeJsObject3D read fLine;
    property target: TThreeJsObject3D read fTarget;
    property children: TJSArray read fChildren;
    property currentHex: JSValue read fCurrentHex write fCurrentHex;
    property parent: TThreeJsObject3D read fParent;
    property visible: boolean read fVisible write fVisible;
    property geometry: TThreeJsGeometry read fGeometry write fGeometry;
    property center: TThreeJsVector3 read fCenter write fCenter;
  end;

  TThreeJsBox3 = class external name 'THREE.Box3' (TJSObject)
  public
    procedure setFromObject(anObhect: TThreeJsObject3D);
    function getBoundingSphere: TThreeJsObject3D;
    function getCenter(aCenter: TThreeJsVector3): TThreeJsVector3;
    property min: TThreeJsVector3 read fMin write fMin;
    property max: TThreeJsVector3 read fMax write fMax;
  end;

  TThreeJsScene = class external name 'THREE.Scene' (TThreeJsObject3D)
  public
    constructor New;
  end;

  TThreeJsCamera = class external name 'THREE.PerspectiveCamera' (TThreeJsObject3D)
  public
    constructor New(fov, aspect, anear, afar: double);
    procedure updateProjectionMatrix;
    property fov: double read fFov write fFov;
    property aspect: double read fAspect write fAspect;
  end;

  TThreeJsLight = class external name 'THREE.Light' (TThreeJsObject3D)
  public
    constructor New(aColorHex: JSValue);
    constructor New(aColorHex: JSValue; aIntensity: double);
    property intensity: double read fIntensity write fIntensity;
    property decay: double read fDecay write fDecay;
    property colorHtml: TThreeJsColor read fColor write fColor;
  end;

  TThreeJsLightHelper = class helper for TThreeJsLight
  protected
    procedure SetColor(AValue: TColor);
    function GetColor: TColor;
  public
    property Color: TColor read GetColor write SetColor;
  end;

  TThreeJsSpotLight = class external name 'THREE.SpotLight' (TThreeJsLight)
  end;

  TThreeJsAmbientLight = class external name 'THREE.AmbientLight' (TThreeJsLight)
  end;

  TThreeJsDirectionalLight = class external name 'THREE.DirectionalLight' (TThreeJsLight)
  end;

  TThreeJsAxes = class external name 'THREE.AxesHelper' (TThreeJsObject3D)
  public
    constructor New(length : double);
  end;

  TThreeJsGrid = class external name 'THREE.GridHelper' (TThreeJsObject3D)
  public
    constructor New(size: integer; divisions: integer; colorCenterLine, colorGrid: JSValue);
  end;

  TThreeJsBoxGeometry = class external name 'THREE.BoxGeometry' (TThreeJsGeometry)
  public
    constructor New(width : double; height : double; depth : double);
  end;

  TThreeJsBufferGeometry = class external name 'THREE.BufferGeometry' (TThreeJsGeometry)
  public
    constructor New;
    function fromGeometry(Geometry: TThreeJsGeometry): TThreeJsBufferGeometry;
  end;

  TThreeJsExtrudeBufferGeometry = class external name 'THREE.ExtrudeBufferGeometry' (TThreeJsGeometry)
  public
    constructor New(shape: TThreeJsShape; extrudeSettings: TJSObject);
  end;

  TThreeJsMesh = class external name 'THREE.Mesh' (TThreeJsObject3D)
  public
    constructor New(geometry: TJSObject; material: TJSObject);
  end;

  TThreeJsWebGLShadowMap = class external name 'THREE.WebGLShadowMap' (TJSObject)
  public
    property enabled: boolean read fEnabled write fEnabled;
  end;

  TThreeJsRenderer = class external name 'THREE.WebGLRenderer' (TJSObject)
  public
    constructor New;
    constructor New(parameters: TJSObject);
    function domElement: TJSElement;
    procedure setSize(width, height: integer);
    procedure render(scene: TThreeJsScene; camera: TThreeJsCamera);
    procedure setClearColor(aColor: TThreeJsColor; alpha: double);
    function getMaxAnisotropy: Integer;
    property ShadowMap: TThreeJsWebGLShadowMap read fShadowMap write fShadowMap;
    property gammaOutput: boolean read fGammaOutput write fGammaOutput;
    property gammaFactor: double read fGammaFactor write fGammaFactor;
  end;

  TThreeJsOrbitControls = class external name 'THREE.OrbitControls' (TJSEventTarget)
  public
    constructor New(aCamera: TThreeJsCamera; domElement: TJSElement);
    procedure saveState;
    procedure reset;
    procedure update;
    procedure rotateLeft(angleRad: double); external name 'rLeft';
    procedure rotateUp(angleRad: double); external name 'rUp';
    procedure zoomIn(deltaScale: double);
    procedure panIt(deltaX, deltaY: double);
    procedure dumpPosition;
    procedure removeMouseDown;
    procedure onMouseDownEvent(Event: TJSEvent);
    procedure removeMouseMove;
    procedure onMouseMoveEvent(Event: TJSEvent);
    procedure removeKeyDown;
    procedure onKeyDownEvent(Event: TJSEvent);
    function isRotatingOrPanning: boolean;
    property target: TThreeJsVector3 read fTarget;
    property keyPanSpeed: double read fKeySpanSpeed;
    property enabled: boolean read fEnabled write fEnabled;
    property enableRotate: boolean read fEnableRotate write fEnableRotate;
  end;

  TThreeJsPlaneGeometry = class external name 'THREE.PlaneGeometry' (TThreeJsGeometry)
  public
    constructor New(width : double; height : double);
    constructor New(width : double; height : double; widthSegments: integer);
    constructor New(width : double; height : double; widthSegments: integer; heightSegments: integer);
    procedure computeFaceNormals;
    procedure computeVertexNormals;
    property verticesNeedUpdate: boolean read fVerticesNeedUpdate write fVerticesNeedUpdate;
    property normalsNeedUpdate: boolean read fNormalsNeedUpdate write fNormalsNeedUpdate;
    property colorsNeedUpdate: boolean read fColorsNeedUpdate write fColorsNeedUpdate;
  end;

  TThreeJsPlaneBufferGeometry = class external name 'THREE.PlaneBufferGeometry' (TJSObject)
  public
    constructor New(width : double; height : double; widthSegments: integer; heightSegments: integer);
  end;

  TThreeJsSphereGeometry = class external name 'THREE.SphereGeometry' (TJSObject)
  public
    constructor New(radius: double; widthSegments: integer; heightSegments: integer);
  end;

  TThreeJsArrow = class external name 'THREE.ArrowHelper' (TThreeJsObject3D)
  public
    constructor New(dir, origin: TThreeJsVector3; length: double; hexColor: JSValue);
  end;

  TThreeJsRaycaster = class external name 'THREE.Raycaster' (TJSObject)
  public
    constructor New;
    procedure setFromCamera(coords: TThreeJsVector2; camera: TThreeJsCamera);
    function intersectObjects(objects: TJSArray; recursive: Boolean): TJSArray;
  end;

  TThreeJsCylinderGeometry = class external name 'THREE.CylinderGeometry' (TJSObject)
  public
    constructor New(radiusTop, radiusBottom, height: double; radialSegments: integer);
  end;

  TThreeJsMeshLine = class external name 'MeshLine' (TJSObject)
  public
    constructor New;
    procedure setGeometry(aGeometry: TThreeJsGeometry);
    property geometry: TThreeJsGeometry read fGeometry write fGeometry;
  end;

  TThreeJsCurve = class external name 'THREE.Curve' (TJSObject)
  public
    constructor New;
  end;

  TThreeJsCatmullRomCurve3 = class external name 'THREE.CatmullRomCurve3' (TThreeJsCurve)
  public
    constructor New(points: TJSArray);
  end;

  TThreeJsTubeGeometry = class external name 'THREE.TubeGeometry' (TThreeJsGeometry)
  public
    constructor New(path: TThreeJsCurve; tubularSegments: Integer; radius: double; radialSegments: Integer; closed: Boolean);
  end;

  TThreeJsIntersection = class external name 'Object' (TJSObject)
  public
    property point: TThreeJsVector3 read fPoint;
    // can not use object as property in Delphi so theObject
    property theObject: TThreeJsObject3D read fObject;
    property distance: double read fDistance;
    property faceIndex: integer read fFaceIndex;
    property face: TThreeJsFace3 read fFace;
  end;

  TThreeJsDefaultLoadingManagerLoadEvent = reference to procedure;

  TThreeJsDefaultLoadingManager = class external name 'THREE.DefaultLoadingManager' (TJSObject)
  public
    class var fOnLoad: TThreeJsDefaultLoadingManagerLoadEvent; external name 'onLoad';
    class property onLoad: TThreeJsDefaultLoadingManagerLoadEvent read fOnLoad write fOnLoad;
  end;

  // In case of error, JS sends error object with message
  TThreeJsLoadObjectEventJS = reference to procedure(success: boolean; anObject: TJSObject);

  //From our ThreeUtils
  function makeTextSprite(text: string; x, y, z: double; parameters: TJSObject): TThreeJsObject3D; external name 'makeTextSprite';
  function createChartGrid(options: TJSObject): TThreeJsObject3D; external name 'createChartGrid';
  function niceScale(minValue, maxValue: double): TJSObject; external name 'niceScale';
  procedure setSurfaceGradient(geometry: TThreeJsGeometry; colors: TJSArray; axis: string; reverse: boolean); external name 'setSurfaceGradient';
  procedure loadObjectMtl(anObjName, objFile, objPath,
               mtlFile, mtlPath, texturePath: string;
               aPosition: TThreeJsVector3;
               doneCallback: TThreeJsLoadObjectEventJS); external name 'loadObjectMtl';
  procedure loadObjectGltf(anObjName, gltfFile, gltfPath: string;
               aPosition: TThreeJsVector3;
               doneCallback: TThreeJsLoadObjectEventJS); external name 'loadObjectGltf';
  procedure exportGltf(aScene: TThreeJsScene; gltfFileName: string); external name 'exportGltf';


  // Delphi counterpart for the above
type
  TTXVerticalAlign = (txvCenter, txvTop, TxvBottom);
  TTXHorizontalAlign = (txhCenter, txhLeft, TxhRight);

  // Important: If you ever change default values, change
  // them in measureTextWidth too.
  function makeATextSprite(text: string; x, y, z: double;
    isFixed: boolean;
    isDrawTopmost: boolean;
    // alignment of whole sprite with respect to x , y, z point
    valign: TTXVerticalAlign;
    halign: TTXHorizontalAlign;
    // alignment of internal text in case of Multi-line text
    halignMultiLineText: TTXHorizontalAlign;
    textColorHex: JSValue;
    fontFace: string;
    fontHeight: double; //in webGL units
    isBold: boolean;
    isTransparentFill: boolean;
    fillColorHex: JSValue;
    borderWidth: double;
    borderColorHex: JSValue;
    margin: double = 24;
    radius: double = 6
    ): TThreeJsObject3D;

   function measureTextWidth(text: string;
    fontFace: string = 'Arial';
    fontHeight: double = 1; //in webGL units
    isBold: boolean = false;
    borderWidth: double = 0;
    margin: double = 24;
    radius: double = 6
    ): double;


   function createAChartGrid(aWidth, aHeight: double;
      numDivisionsHorizontal, numDivisionsVertical : integer;
      aGridColor: JSValue=$ffffff; aLineColor: JSValue=$000000;
      isThickLines:boolean=false; isTransparentFill:boolean=false): TThreeJsObject3D;

   procedure getNiceScale(minVal, maxVal: double;
                    out niceMinimum: double;
                    out niceMaximum: double;
                    out tickSpacing: double);

   function makeLegendSprite(
              lines: string;
              // pass color1, color2, ... corresponding to lines
              colorList: TJSArray;
              shapeList: TJSArray;
              textColorHex: JSValue = $000000;
              fontFace: string = 'Arial';
              fontHeight: double = 1; //in webGL units
              isBold: boolean = false;
              isTransparentFill: boolean = true;
              fillColorHex: JSValue = $ffffff;
              borderWidth: double = 0;
              borderColorHex: JSValue = $ADD8E6;
              margin: double = 24;
              radius: double = 6
              ): TThreeJsObject3D;

  function getColorObject(aColorHex: JSValue): TJSObject;
  function getTColor(aThreeJsColor: TThreeJsColor): TColor;
  function ColorToHtmlNumber(aColor: TColor): JSValue;

var
  MaxAnisotropy: Integer = 16;

implementation
end.
