{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2020                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Actions;

{$DEFINE NOPP}

interface

uses
  Classes, Web, JS, WEBLib.Controls;

type
  THTMLEvent = (heClick,heDblClick,heKeypress,heKeydown,heKeyup,heMouseDown,heMouseMove,heMouseUp,heMouseEnter,heMouseLeave,heBlur,heFocus,heChange,heSelect,heInput,heInvalid,heCustom,heNone);

  THTMLAction = (actNone, actSetHidden, actRemoveHidden, actToggleHidden, actSetReadOnly, actRemoveReadOnly, actToggleReadOnly, actSetDisabled, actRemoveDisabled, actToggleDisabled, actClear);

  TJSEventParameter = record
    JSEvent: TJSEvent;
  end;

  THTMLEventEvent = procedure(Sender: TObject; Element: TJSHTMLElementRecord; Event: TJSEventParameter) of object;

  THTMLUpdateEvent = procedure(Sender: TObject; Element: TJSHTMLElementRecord; Event: TJSEventParameter; TargetElement: TJSHTMLElementRecord) of object;

  TCustomHTMLEvent = type string;

  TElementArray = array of TJSElement;

  TElementAction = class(TCollectionItem)
  protected
    function GetDisplayName: string; override;
    function DoHandleEvent(Event: TJSEvent): Boolean;
    procedure DoAction(AEvent: TJSEvent; SrcElement, AElement: TJSElement); virtual;
    procedure BindEvent(AEvent: THTMLEvent; AElement: TJSElement); virtual;
    procedure UnBindEvent(AEvent: THTMLEvent; AElement: TJSElement); virtual;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    procedure Bind;
    procedure UnBind;
    property ElementHandle: TJSElement read FElementHandle;
    property ElementHandles: TElementArray read FElementHandles;
  published
    property Control: TControl read FControl write FControl;
    property CustomEvent: TCustomHTMLEvent read FCustomEvent write FCustomEvent;
    property Enabled: boolean read FEnabled write FEnabled default true;
    property Event: THTMLEvent read FElementEvent write SetElementEvent default heClick;
    property ID: TElementID read FElementID write SetElementID;
    property Name: string read FName write SetName;
    property PreventDefault: boolean read FPreventDefault write FPreventDefault default true;
    property Selector: string read FSelector write SetSelector;
    property StopPropagation: boolean read FStopPropagation write FStopPropagation default true;
    property Tag: integer read FTag write FTag default 0;
    property TargetAction: THTMLAction read FTargetAction write FTargetAction default actNone;
    property TargetControl: TControl read FTargetControl write  FTargetControl;
    property TargetID: TElementID read FTargetID write FTargetID;
    property TargetSelector: string read FTargetSelector write FTargetSelector;
    property OnExecute: THTMLEventEvent read FOnExecute write FOnExecute;
    property OnUpdate: THTMLUpdateEvent read FOnUpdate write FOnUpdate;
  end;

  TElementActions = class(TOwnedCollection)
  protected
  public
    constructor Create(AOwner: TComponent); reintroduce;
    function Add: TElementAction; reintroduce;
    function Insert(AIndex: integer): TElementAction; reintroduce;
    property Items[AIndex: integer]: TElementAction read GetItems write SetItems; default;
    property Action[AName: string]: TElementAction Read GetAction;
    function GetActionByName(AName: string): TElementAction;
    function GetByName(AName: string): TElementAction;
    function FindByName(AName: string): TElementAction;
  end;


  THTMLActionEventEvent = procedure(Sender: TObject; AAction: TElementAction; Element: TJSHTMLElementRecord; Event: TJSEventParameter) of object;

  THTMLActionUpdateEvent = procedure(Sender: TObject; AAction: TElementAction; Element: TJSHTMLElementRecord; Event: TJSEventParameter; TargetElement: TJSHTMLElementRecord) of object;


  TElementActionList = class(TComponent)
  protected
    procedure BeforeLoadDFMValues; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure BindActions;
    procedure UnBindActions;
    procedure Loaded; override;
    property Action[AName: string]: TElementAction Read GetAction; default;
    function GetActionByName(AName: string): TElementAction;
    function GetByName(AName: string): TElementAction;
    function FindByName(AName: string): TElementAction;
  published
    property Actions: TElementActions read FActions write SetActions;
    property OnExecute: THTMLActionEventEvent read FOnExecute write FOnExecute;
    property OnUpdate: THTMLActionUpdateEvent read FOnUpdate write FOnUpdate;
  end;

  TWebElementActionList = class(TElementActionList);


implementation
end.
