{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            Copyright (c) 2018 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Lists;

{$DEFINE NOPP}

interface

uses
  Classes, Web, WEBLib.Controls, WEBLib.Dialogs;

type
  TListItem = class;
  TListItems = class;
  TListControl = class;

  TListStyle = (lsNone, lsPagination, lsTabs, lsBreadcrumb, lsListGroup, lsListGroupHorizontal, lsNavPills, lsNavPillsHorizontal);

  TListGetItemClassEvent = procedure(Sender: TObject; AItem: TListItem; var AClassName: string) of object;

  TListGetItemChildrenEvent = procedure(Sender: TObject; AItem: TListItem; AElement: TJSHTMLElementRecord) of object;

  TListItemEvent = procedure(Sender: TObject; AListItem: TListItem) of object;

  TListItem = class(TCollectionItem)
  protected
    procedure SubItemsChanged(Sender: TObject); virtual;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function ItemId: string;
    procedure Store;
    procedure Restore;
  public
    property ListElement: TJSElement read FListElement;
    procedure AddLink(const AURL: string; ATarget: string = ''); overload;
    procedure AddLink(const AURL: string; ATarget: string; AClass: string); overload;
    function IsLink: boolean;
    function IsCollapsed: boolean;
    procedure Expand;
    procedure Collapse;
  published
    property Active: boolean read FActive write SetActive;
    property AutoCollaps: boolean read FAutoCollaps write SetAutoCollaps;
    property Enabled: boolean read FEnabled write SetEnabled;
    property Hint: string read FHint write SetHint;
    property ItemClassName: TElementClassName read FItemClassName write FItemClassName;
    property Items: TListItems read FItems write SetItems;
    property Link: string read FLink write SetLink;
    property LinkClassName: TElementClassName read FLinkClassName write FLinkClassName;
    property LinkTarget: string read FLinkTarget write FLinkTarget;
    property Tag: integer read FTag write FTag;
    property Text: string read FText write SetText;
  end;

  TListItems = class(TOwnedCollection)
  protected
    procedure Update(Item: TCollectionItem); override;
    procedure DoChanged; virtual;
    procedure Store;
    procedure Restore;
  public
    constructor Create(AOwner: TPersistent);
    function Add: TListItem; reintroduce;
    function Insert(Index: integer): TListItem; reintroduce;
    property Items[Index: integer]: TListItem read GetItem write SetItem; default;
    property ListControl: TListControl read GetListControl;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

  TListControl = class(TCustomControl)
  protected
    function HandleDoClick(Event: TJSMouseEvent): Boolean; override;
    function HandleDoDblClick(Event: TJSMouseEvent): Boolean; override;
    function HandleDoAnchorClick(Event: TJSEvent): Boolean; virtual;
    procedure ItemsChanged(Sender: TObject); virtual;
    procedure ItemClick(AItem: TListItem); virtual;
    procedure ItemDblClick(AItem: TListItem); virtual;
    procedure GetItemClass(Item: TListItem; var AClass: string); virtual;
    procedure GetItemChildren(Item: TListItem; AElement: TJSHTMLElement); virtual;
    function CreateElement: TJSElement; override;
    procedure UpdateElement; override;
    procedure RenderList(AElement: TJSElement; Items: TListItems);
    function ListItemByElement(AElement: TJSElement): TListItem;
    procedure EnableDrag; override;
    procedure DisableDrag; override;
  public
    constructor Create(AOwner: TComponent); override;  overload;
    destructor Destroy; override;
    procedure CreateInitialize; override;
    function ListElement: TJSHTMLElement;
    property ItemIndex: integer read GetItemIndex write SetItemIndex;
  published
    property Align;
    property AlignWithMargins;
    property Anchors;
    property ChildOrder;
    property DefaultItemClassName: string read FDefaultItemClassName write FDefaultItemClassName;
    property DefaultItemLinkClassName: string read FDefaultItemLinkClassName write FDefaultItemLinkClassName;
    property DragMode;
    property ElementClassName;
    property ElementFont;
    property ElementID;
    property ElementPosition;
    property ElementListClassName: TElementClassName read FElementListClassName write SetElementListClassName;
    property HeightPercent;
    property HeightStyle;
    property Items: TListItems read FItems write SetItems;
    property Margins;
    property Style: TListStyle read FListStyle write SetListStyle;
    property Visible;
    property WidthPercent;
    property WidthStyle;

    property OnGetItemChildren: TListGetItemChildrenEvent read FOnGetItemChildren write FOnGetItemChildren;
    property OnGetItemClass: TListGetItemClassEvent read FOnGetItemClass write FOnGetItemClass;
    property OnItemClick: TListItemEvent read FOnItemClick write FOnItemClick;
    property OnItemDblClick: TListItemEvent read FOnItemDblClick write FOnItemDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
  end;

  TWebListControl = class(TListControl);

implementation
end.
