unit libfaunadb;

interface

uses
  JS, Web, JSDelphiSystem;

type
  TFaunaDbError = Class
  private
    FMessage: String;
    FName: String;
  Public
    property message : String Read FMessage;
    property name : String Read FName;
  end;

  TFaunaDbSet = class(TJSObject)
  end;

  TFaunaDbPages = class(TJSArray)
  end;

  TFaunaDbLambda = class(TJSObject)
  end;

  TFaunaDbFunction = class(TJSObject)
  end;

  TFaunaDbInstance = class(TJSObject)
  private
    fId: String;
  public
    property id: String read fId;
  end;

  TFaunaDbIndex = class(TJSObject)
  private
    fRef: TFaunaDbInstance;
  public
    property ref: TFaunaDbInstance read fRef;
  end;

  TFaunaDbDocument = class(TJSObject)
  private
    fData: TJSObject;
    fRef: TFaunaDbInstance;
  public
    property data: TJSObject read fData;
    property ref: TFaunaDbInstance read fRef;
  end;

  TFaunaDbAuth = class(TJSObject)
  private
    fSecret: String; 
    fInstance: TFaunaDbInstance; 
  public
    property instance: TFaunaDbInstance read fInstance;
    property secret: String read fSecret;
  end;

  TFaunaDbQuery = class(TJSObject)
  public
    function Create(aCollection: TFaunaDbInstance; paramObject: TJSObject): TJSObject;
    function CreateIndex(paramObject: TJSObject): TFaunaDbIndex;
    function Collection(aCollection: String): TFaunaDbInstance;
    function Delete(aDocRef: TFaunaDbInstance): TJSObject;
    function Exists(aReference: TJSObject): Boolean;
    function Get(aValue: JSValue): JSValue;
    function GetVar(aName: String): JSValue;
    function Index(name: String): TFaunaDbInstance;
    function Lambda(aVar: String; anExpr: JSValue): TFaunaDbLambda;
    function Login(aRef: TFaunaDbSet; paramObject: TJSObject): TFaunaDbAuth;
    procedure Logout(RemoveAllTokens: Boolean);
    function Map(anArray: TJSArray; aLambda: TFaunaDbLambda): TJSArray;
    function Match(anIndex: TFaunaDbInstance): TFaunaDbSet; overload;
    function Match(anIndex: TFaunaDbInstance; aValue: String): TFaunaDbSet; overload;
    function Paginate(aSet: TFaunaDbSet): TFaunaDbPages;
    function Ref(aRef: TFaunaDbInstance): TFaunaDbInstance; overload;
    function Ref(aRef: TFaunaDbInstance; anId: String): TFaunaDbInstance; overload;
    function Select(path: JSValue; from: JSValue): JSValue;
    function Update(aDocRef: TFaunaDbInstance; paramObject: TJSObject): TJSObject;
    function theFunction(aName: String): TFaunaDbFunction;
    function Call(aFunction: TFaunaDbFunction; args: TJSArray): JSValue;
  end;

  TFaunaDbClient = class(TJSObject)
  public
    constructor New(config: TJSObject);
    function query(params: JSValue): TJSPromise;
  end;

  TFaunaDb = class(TJSObject)
  private
    class var fquery: TFaunaDbQuery;
  public
    class property query: TFaunaDbQuery read fquery;
  end;

implementation
{$HINTS OFF}
{$WARNINGS OFF}

function TFaunaDbQuery.Create(aCollection: TFaunaDbInstance; paramObject: TJSObject): TJSObject;
begin
end;

function TFaunaDbQuery.CreateIndex(paramObject: TJSObject): TFaunaDbIndex;
begin
end;

function TFaunaDbQuery.Collection(aCollection: String): TFaunaDbInstance;
begin
end;

function TFaunaDbQuery.Delete(aDocRef: TFaunaDbInstance): TJSObject;
begin
end;

function TFaunaDbQuery.Exists(aReference: TJSObject): Boolean;
begin
end;

function TFaunaDbQuery.Get(aValue: JSValue): JSValue;
begin
end;

function TFaunaDbQuery.GetVar(aName: String): JSValue;
begin
end;

function TFaunaDbQuery.Index(name: String): TFaunaDbInstance;
begin
end;

function TFaunaDbQuery.Lambda(aVar: String; anExpr: JSValue): TFaunaDbLambda;
begin
end;

function TFaunaDbQuery.Login(aRef: TFaunaDbSet; paramObject: TJSObject): TFaunaDbAuth;
begin
end;

procedure TFaunaDbQuery.Logout(RemoveAllTokens: Boolean);
begin
end;

function TFaunaDbQuery.Map(anArray: TJSArray; aLambda: TFaunaDbLambda): TJSArray;
begin
end;

function TFaunaDbQuery.Match(anIndex: TFaunaDbInstance): TFaunaDbSet;
begin
end;

function TFaunaDbQuery.Match(anIndex: TFaunaDbInstance; aValue: String): TFaunaDbSet;
begin
end;

function TFaunaDbQuery.Paginate(aSet: TFaunaDbSet): TFaunaDbPages;
begin
end;

function TFaunaDbQuery.Ref(aRef: TFaunaDbInstance): TFaunaDbInstance;
begin
end;

function TFaunaDbQuery.Ref(aRef: TFaunaDbInstance; anId: String): TFaunaDbInstance;
begin
end;

function TFaunaDbQuery.Select(path: JSValue; from: JSValue): JSValue;
begin
end;

function TFaunaDbQuery.Update(aDocRef: TFaunaDbInstance; paramObject: TJSObject): TJSObject;
begin
end;

function TFaunaDbQuery.theFunction(aName: String): TFaunaDbFunction;
begin
end;

function TFaunaDbQuery.Call(aFunction: TFaunaDbFunction; args: TJSArray): JSValue;
begin
end;

constructor TFaunaDbClient.New(config: TJSObject);
begin
end;

function TFaunaDbClient.query(params: JSValue): TJSPromise;
begin
end;

end.
